-- INIT VARS
local DEBUG = false
local DEBUGLOG = false

local filenameBase = "InherentResolve"
local bluePlayers = "Coalition"
local redPlayers = "Islamic State"
local blueFaction = "Coalition"
local redFaction = "Islamic State"

-- Logbook Vars
local logbookSplitter = ":"
local logbookMission = "OIR"
local redCode = 22
local blueCode = 20
-- fine Logbook

-- *** 1. CHECKLIST ATTIVITA' SU LUA PER CUSTOMIZZARE ***
  -- * setStage(day) -> Qui personalizzi la distribuzione delle unità in base agli stage -> va creata la dinamica per generare a seconda della parte della mappa
  -- * getStageInfo (client) -> Messaggi dei vari passaggi di stage per l'evoluzione del conflitto
  -- * addHandlersClient (client) -> Messaggio fine conflitto, limite e gestione della variabile day
  -- * totalAircraftRED e totalAircraftBLUE -> Imposta il numero di aerei di ambo le fazioni
  -- * DEFINE RED SPAWNS e DEFINE BLUE SPAWNS -> In unione con la mappa definisci tutti i gruppi LATE ACTIVATION
  -- * Vedere se non c'è da escludere qualche base in "FIND RED AIRBASES" e "FIND BLUE AIRBASES", questo le esclude completamente dalle logiche
  -- * Personalizzare in base al contesto ed alla mappa i "DEFINE SAM RISK RANGES" e i relativi criteri di riconosimento in riskLevel(), per il riconoscimento puoi aiutarti con DEBUG o DEBUGLOG che attiva la visualizzazione della lista delle unità

-- *** 2. CHECKLIST ATTIVITA' SU MAPPA PER CUSTOMIZZARE ***
  -- * Selezionare sulla mappa quali aeroporti usare tra RED e BLUE
  -- * Creare le zone con prefisso "Geo " che serviranno per la localizzazione dei vari gruppi, dimensione e lato del fronte non sono considerati

  -- A. CREAZIONE TEMPLATE GRUPPI AEROMOBILI AI - Tutti i gruppi devono essere in LATE ACTIVATION
    -- * Creare i gruppi CAP sulla mappa impostando i task e armamenti. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE CAP" e "RED CAP". I gruppi reamente usati come template dovranno avere i prefissi "BLUE CAP" e "RED CAP"
    -- * Creare i gruppi CAS sulla mappa impostando i task e armamenti. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE CAS" e "RED CAS". I gruppi reamente usati come template dovranno avere i prefissi "BLUE CAS" e "RED CAS"
    -- * Creare i gruppi SEAD sulla mappa impostando i task e armamenti. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE SEAD" e "RED SEAD". I gruppi reamente usati come template dovranno avere i prefissi "BLUE SEAD" e "RED SEAD"

  -- B. CREAZIONE GRUPPI AEROMOBILI CLIENT
    -- * Se necessario creare gruppi di aerei client per CAP avendo cura di impostare task e armamenti. I nomi devono essere nel formato "CAP-[n] - [nome aeroporto]"
    -- * Se necessario creare gruppi di aerei client per CAS avendo cura di impostare task e armamenti. I nomi devono essere nel formato "CAS-[n] - [nome aeroporto]"
    -- * Se necessario creare gruppi di aerei client per SEAD avendo cura di impostare task e armamenti. I nomi devono essere nel formato "SEAD-[n] - [nome aeroporto]"
    -- * Se necessario creare gruppi di aerei client per Strike avendo cura di impostare task e armamenti. I nomi devono essere nel formato "Strike-[n] - [nome aeroporto]"
    -- * Crea anche qualsiasi altro slot necessario, considera però che nel caso saranno necessarie modifiche sotto

  -- C. CREAZIONE TEMPLATE GRUPPI TERRESTRI - Tutti i gruppi devono essere in LATE ACTIVATION
    -- * Creare i gruppi ARTILLERY sulla mappa. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE ARTILLERY" e "RED ARTILLERY". I gruppi reamente usati come template dovranno avere i prefissi "BLUE ARTILLERY" e "RED ARTILLERY"
    -- * Creare i gruppi ARMOR sulla mappa. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE ARMOR" e "RED ARMOR". I gruppi reamente usati come template dovranno avere i prefissi "BLUE ARMOR" e "RED ARMOR"
    -- * Creare i gruppi BASE sulla mappa. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE BASE" e "RED BASE". I gruppi reamente usati come template dovranno avere i prefissi "BLUE BASE" e "RED BASE"
    -- * Creare i gruppi SAM sulla mappa. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE SAM" e "RED SAM". I gruppi reamente usati come template dovranno avere i prefissi "BLUE SAM" e "RED SAM" (Questi al momento non sono usati)
    -- * Creare i gruppi AIR DEFENCE sulla mappa. Devono essere creati 4 gruppi "modello" inutilizzati denominati "BLUE AIRBASE AIR DEFENCE", "RED AIRBASE AIR DEFENCE", "BLUE TMP AIR DEFENCE" e "RED TMP AIR DEFENCE". I gruppi reamente usati come template dovranno avere i prefissi "BLUE AIR DEFENCE" e "RED AIR DEFENCE"
    -- * Creare i gruppi CONVOY sulla mappa. Devono essere creati 2 gruppi "modello" inutilizzati denominati "BLUE CONVOY" e "RED CONVOY". I gruppi reamente usati come template dovranno avere i prefissi "BLUE CONVOY" e "RED CONVOY". I gruppi devono essere di una unità, questa unità verrà replicata per costituire i convogli

  -- D. POPOLAMENTO DELLA MAPPA
    -- * Creare sulla mappa i gruppi SAM con i prefissi "RED SAM" e "BLUE SAM" - NOTA: I SAM non vengono creati via codice, vengono usati solo quelli della mappa
    -- * Creare sulla mappa i gruppi per le difese aeree con i prefissi "RED AIR DEFENCE" e "BLUE AIR DEFENCE" - NOTA: Le difese aeree vengono create anche via codice, un set per ogni aeroporto. Va considerato che vengono generate difese aeree temporanee anche via codice per proteggere le strutture, che però non vengono salvate tra una missione l'altra.
    -- * Se serve è possibile posizionare qualsiasi altro gruppo sulla mappa, senza i prefissi utilizzati per setStage() questi saranno salvati e ripresentati
    -- * Per creare degli static nelle basi (RED_AIRBASE_SET e BLUE_AIRBASE_SET) che possono essere attaccati, vanno inseriti il nome della base come prefisso, quello indicato in mappa dovrebbe andare benissimo per esempio [nome base]-[indice statico]

  -- E. CREAZIONE ZONE PER SETSTAGE
    -- * Creare sulla mappa le zone per generare gli armor (consigliato circolare raggio 250) in base alla funzione setStage(), devono avere formato "Armor-[numero]" - NOTA: Gli armor non vengono salvati tra una missione l'altra. Puoi sempre posizionare gruppi di armor direttamente sulla mappa ma devono avere prefissi "RED ARMOR" o "BLUE ARMOR" per essere usati come obiettivi.
    -- * Creare sulla mappa le zone per generare le artiglierie (consigliato circolare raggio 250) in base alla funzione setStage(), devono avere formato "Arty-[numero]" - NOTA: Le artiglierie non vengono salvate tra una missione l'altra. Puoi sempre posizionare gruppi di artiglierie direttamente sulla mappa ma devono avere prefissi "RED ARTILLERY" o "BLUE ARTILLERY" per essere usati come obiettivi.
    -- * Creare sulla mappa le zone per generare le basi nemiche (consigliato circolare raggio 250) in base alla funzione setStage(), devono avere formato "Base-[numero]" - NOTA: le basi non vengono salvati tra una missione l'altra. Puoi sempre posizionare le basi direttamente sulla mappa ma devono avere prefissi "RED BASE" o "BLUE BASE" per essere usati come obiettivi.

  -- F. CREAZIONE ZONE PER AZIONI AEREE
    -- * Creare "redCapZone" per CAP immediato red, considerare le dimensioni perchè la creazione avviene in un punto casuale della zona
    -- * Creare "blueCapZone" per CAP immediato red, considerare le dimensioni perchè la creazione avviene in un punto casuale della zona
    -- * Creare "redZone1" e "redZone2" per missioni immediate red, considerare le dimensioni perchè la creazione avviene in un punto casuale della zona
    -- * Creare "blueZone1" e "blueZone1" per missioni immediate blue, considerare le dimensioni perchè la creazione avviene in un punto casuale della zona
    -- * Creare la zone Helicopter "BLUE_CAP_ZONE" e "RED_CAP_ZONE" per lo l'area di competenza dei CAP, nel caso vedi taskCAP (grp)

  -- G. CREAZIONE ZONE PER CONVOGLI E STRUTTURE
    -- * Creare le zone con prefisso "BLUE CONVOY ORIGIN" e "RED CONVOY ORIGIN" che serviranno per l'origine dei convogli random, non considerare la dimensione, i convogli si generano nella coordinata centrale
    -- * Creare le zone con prefisso "BLUE CONVOY DESTINATION" e "RED CONVOY DESTINATION" che serviranno per la destinazione dei convogli random, considerare le dimensioni perchè la destizione viene collocato in un punto casuale della zona
    -- * Creare congrua quantità di zone per selezione degli scenery nella mappa, per farlo crea delle zone che possano raggruppare anche più strutture e denominate con i prefissi "BLUE SCENERY" e "RED SCENERY". Procedi poi a creare una proprietà denominata "NAME" valorizzandola con il nome del gruppo di strutture che apparirà nel briefing, usa lettere maiuscole.
    -- * Creare zone per selezione delle piste nella mappa attraverso zone perimetrate sulle piste e con i prefissi "BLUE RUNWAY" e "RED RUNWAY". Procedi poi a creare una proprietà denominata "NAME" valorizzandola con l'indicazione della pista tipo "RUNWAY 15L/28R".

-- *** 3. ULTERIORI CUSTOMIZZAZIONI PER QUESTO LUA ***
  -- * selectTask(side) -> Se serve personalizzare i pesi delle missioni per AI, questo va fatto in base alle unita sulla mappa
  -- * dispatcher(side, immediateSpawnZone) -> puoi escludere le basi con piste troppo corte e regolare i bilanciamenti tra i gruppi in volo e le basi attive
  -- * showGroundTargetInfo (client) e showConvoyTargetInfo (client) e showAirTargetInfo (client) e fn_GetTarget(client) -> qui si possono personalizzare i briefing
  -- * GCIMessage (client) -> se serve si può personalizzare il messaggio del controllo da terra
  -- * showJDAMcoord (client) -> puoi cambiare il modo in cui vengono esposte le coordinate, in un contesto moderno si può aumentare la precisione o aggiungere la griglia
  -- * checkTarget (client) e checkConvoyTarget (client) -> qui puoi regolare le logiche per il successo della missione
  -- * newMenu (client) -> qui puoi personalizzare la gestione dei menu se volessi disattivare l'auto assegnazione di una missione

-- DEFINE RED SPAWNS
--RED_SAMS = {"RED SAM SA-2","RED SAM SA-3","RED SAM SA-6"}
RED_AIR_DEFENCES = {"RED AIR DEFENCE ZU-23","RED AIR DEFENCE S-60","RED AIR DEFENCE ZSU-23","RED AIR DEFENCE ZU-23-2"}
RED_TMP_AIR_DEFENCES = {"RED AIR DEFENCE ZU-23","RED AIR DEFENCE S-60","RED AIR DEFENCE ZSU-23","RED AIR DEFENCE ZU-23-2"}
RED_ARMORS = {"RED ARMOR T-55","RED ARMOR T-62","RED ARMOR BMP-1", "RED ARMOR T-55-2"}
RED_ARTILLERIES = {"RED ARTILLERY BM-21","RED ARTILLERY 2B11","RED ARTILLERY 2S1", "RED ARTILLERY BM21"}
--RED_SEADS = {"RED SEAD Su-17M4"}
RED_CASSES = {"RED CAS MiG-21Bis"}
RED_CAPS = {"RED CAP MiG-21Bis"}
RED_CONVOYS = {"RED CONVOY-1","RED CONVOY-2","RED CONVOY-3","RED CONVOY-4","RED CONVOY-5","RED CONVOY-6","RED CONVOY-7","RED CONVOY-8","RED CONVOY-9"}
-- RED_BASES = {} -- Al momento usa solo un template quindi non serve

-- DEFINE BLUE SPAWNS
--BLUE_SAMS = {"BLUE SAM HAWK"}
BLUE_AIR_DEFENCES = {"BLUE AIR DEFENCE M163","BLUE AIR DEFENCE Stinger"}
BLUE_TMP_AIR_DEFENCES = {"BLUE AIR DEFENCE M163","BLUE AIR DEFENCE Stinger"}
BLUE_ARMORS = {"BLUE ARMOR M1A2","BLUE ARMOR M2A2"}
BLUE_ARTILLERIES = {"BLUE ARTILLERY M109","BLUE ARTILLERY MLRS"}

BLUE_SEADS = {"BLUE SEAD F-16"}
BLUE_CASSES = {"BLUE CAS A-10","BLUE CAS F-15E"}
BLUE_CAPS = {"BLUE CAP F-15C","BLUE CAP F-16","BLUE CAP F-16-2"}

BLUE_SEADS_CVN = {"BLUE SEAD F18"}
BLUE_CASSES_CVN = {"BLUE CAS F18"}
BLUE_CAPS_CVN = {"BLUE CAP F18"}

--BLUE_CONVOYS = {"BLUE CONVOY-1","BLUE CONVOY-2","BLUE CONVOY-2"}
-- BLUE_BASES = {} -- Al momento usa solo un template quindi non serve 
BLUE_JTACS = {"BLUE JTAC-1","BLUE JTAC-2","BLUE JTAC-3"}

targetSearchAttempts = 30

day = 0

local airbaseRadius = 6000 -- spawn radius of units from airbase
local airDefenceRadius = 50 -- spawn radius of structure air defences units
local dynamicZoneRadius = 100 -- spawn radius of dynamicZones used for staged to place armors and similar
local messageTime = 10 -- time (seconds) general message stays on screen
local clientTime = 30 -- time (seconds) client message stays on screen
local targetTime = 60 -- time (seconds) target info stays on screen
local minDispatchTime = 30 -- min time (seconds) next package is dispatched (if conditions are met)
local maxDispatchTime = 300 -- max time (seconds) next package is dispatched (if conditions are met)

local minWaitTime = 10 -- min time (seconds) to wain on station (if conditions are met)
local maxWaitTime = 60 -- max time (seconds) to wain on station (if conditions are met)

metersDistanceToIntercept = 30 --distanza (km) sotto la quale GCI comanda intercettazione per voli CAP client
metersRangeTogheder = 2000
minAltitudeMetersGCI = 5 

spawnArea = 20000 -- distanza (m) sotto la quale viene generato un gruppo CAS vicino ad un altro
minJTACdistance = 400 -- minima distanza (m) a cui si genera un JTAC 
maxJTACdistance = 750 -- massima distanza (m) a cui si genera un JTAC

maxTargetDistance = 270 -- massima distanza (km) di distanza per un target

-- SETTINGS IN MISSION EDITOR
totalAircraftRED = 0
totalAircraftBLUE = 300
AIskillRED = "Excellent"
AIskillBLUE = "Excellent"
spawnType = SPAWN.Takeoff.Hot
spawnTypeCVN = SPAWN.Takeoff.Hot
despawnType = "SHUTDOWN"
cleanupInterval = 300
minSpawnAltitudeMeters = 5500
maxSpawnAltitudeMeters = 8000

maxAirborneRed = 6
maxAirborneBlue = 4

-- LIMITS FOR MISSION SUCCESS
minDestForSuccess = 3
minStructureDestForSuccess = 1
minRunwayBombs1 = 2 --numero di bombe minimo per trigger successo
minRunwayBombs2 = 4 --numero di bombe minimo per trigger distruzione completa

-- SOUND
local beepSound = USERSOUND:New( "Beep.ogg" )
local beepSoundClient = USERSOUND:New( "BeepClient.ogg" )

-- FUNCTIONAL VARS
local initCount = 0
local initMission = false
local airGroups = {}
local targetGroups = {}
local tasks = { "SAM", "ARMOR", "AIR DEFENCE", "ARTILLERY", "CONVOY", "CAP", "STRIKE", "AIRBASE", "RUNWAY", "BASE" }

BOOKED_TARGETS = {}

-- MENU VARS
local messageStatus = {}
local picturesUpdate = {}
local targetStatus = {}
local missionTask = {}
local callOnStation = {}
local onStationVisibility = {}
local isWinchester = {}
local waitingTasking = {}
local menuItems = {}
local clientTargetCount = {}
local clientTargetHits = {} -- solo per RUNWAY
local targetMarks = {}
local targetJTACs = {}
local JTACNames = {}
local JTACFreqs = {}
local sceneryDestroyed = {}
local sceneryTarget = {}
local inAir = {}
local activeTarget = {}
local ASOCTaskCompleted = {}

-- DISABLE SETTING MENU
_SETTINGS:SetPlayerMenuOff()
    
-- INIT BASIC FUNCTIONS
function findPosition (coordinate)
  local randomVec2 = nil
  local surfacetype = nil
  while surfacetype ~= 1 do
    randomVec2 = coordinate:GetRandomVec2InRadius(airbaseRadius)
    local newcoord = COORDINATE:NewFromVec2(randomVec2)
    surfacetype = newcoord:GetSurfaceType()  
  end
  return randomVec2
end

function checkUnitPositions (grp)

  local check = true
  local position = grp:GetCoordinate()
  local u,s,scenery = position:ScanObjects(250, true, true, true)

  if scenery then
    check = false  
  else
    local grpCount = #grp:GetUnits()
    for i = 1, grpCount do
      local unit = grp:GetUnit( i )
      local coordinate = unit:GetCoordinate()
      local surfacetype = coordinate:GetSurfaceType()
      if surfacetype ~= 1 then check = false end
    end  
  end

  return check
end

function removeUnitPositions (grp)
  local grpCount = #grp:GetUnits()
  for i = 1, grpCount do
    local unit = grp:GetUnit( i )
    local coordinate = unit:GetCoordinate()
    local surfacetype = coordinate:GetSurfaceType()
    local u,s,scenery = coordinate:ScanObjects(10, true, true, true)
    if surfacetype ~= 1 or scenery then unit:Destroy() end
  end
end

function getAliveUnitsGrp(grp)
  local aliveUnits = 0
  local grpUnits = grp:GetUnits()
  if grpUnits ~= nil then
    for i = 1, #grpUnits do
      local Unit = grp:GetUnit( i )
      if Unit:IsAlive() then
        aliveUnits = aliveUnits +1
      end    
    end
  end 
  return aliveUnits
end

function unitWithLeader(unit)
  local grp = unit:GetGroup()
  local leaderUnit = grp:GetUnit(1)

  if unit:IsAlive() and unit:GetAltitude(true) > minAltitudeMetersGCI and unit:GetPointVec2():DistanceFromPointVec2(leaderUnit:GetCoordinate()) < metersRangeTogheder then 
    return true
  else
    return false
  end
end

function countHowManyWithLeader(leaderUnit)
  local grp = leaderUnit:GetGroup()
  local grpUnits = grp:GetUnits()
  local groupCount = 0

  if leaderUnit:IsAlive() and leaderUnit:GetAltitude(true) > minAltitudeMetersGCI then
    groupCount = 1
    if grpUnits ~= nil then
      for i = 1, #grpUnits do
        local unit = grp:GetUnit(i)
        if unit:IsAlive() and unit:GetAltitude(true) > minAltitudeMetersGCI and unit:GetName() ~= leaderUnit:GetName() and unit:GetPointVec2():DistanceFromPointVec2(leaderUnit:GetCoordinate()) < metersRangeTogheder then
          groupCount = groupCount + 1
        end
      end
    end
  end
  return groupCount
end

function getAliveUnitsSpawn(spawn)
  local aliveUnits = 0
  if spawn ~= nil then
    local convoyUnit, Index = spawn:GetFirstAliveGroup()
    while convoyUnit ~= nil do
      -- Do actions with the GroupPlane object.
      convoyUnit, Index = spawn:GetNextAliveGroup( Index )
      aliveUnits = aliveUnits + 1
    end
  end
  return aliveUnits
end

function getAliveStructuresZone(zone)
  local aliveCount = 0
  local aliveStructures = SET_SCENERY:NewFromZone(zone):FilterOnce()

  aliveStructures:ForEachScenery(function(scenery)
    if scenery:IsAlive() then 
      aliveCount = aliveCount + 1 
      MESSAGE:New("TARGET " .. scenery:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    end
  end)
  
  return aliveCount
end

function getDestroyedStructures(zone, client)
  --Tanto lo fai nel contenitore
  --SCHEDULER:New( nil, getDestroyedStructures, {zone}, 10 )
  local aliveCount = 0
  local aliveStructures = SET_SCENERY:NewFromZone(zone):FilterOnce()

  aliveStructures:ForEachScenery(function(scenery)
    if scenery:IsAlive() then 
      aliveCount = aliveCount + 1 
      --MESSAGE:New("TARGET VIVO " .. scenery:GetName() .. " - " .. scenery:GetTypeName() .. " - identificato", messageTime, nil ):ToLogIf(DEBUGLOG):ToAll() 

      local presentVivo = false

      for _,v in pairs(sceneryTarget[client]) do
      --for _,v in pairs(sceneryTarget) do
        if v[1] == scenery:GetName() then
          presentVivo = true
          --MESSAGE:New("TARGET VIVO " .. scenery:GetName() .. " - " .. scenery:GetTypeName() .. " - già registrato", messageTime, nil ):ToLogIf(DEBUGLOG):ToAll()
          break
        end
      end

      if not presentVivo then
        table.insert(sceneryTarget[client],{scenery:GetName(),scenery:GetTypeName()})
        --table.insert(sceneryTarget,{scenery:GetName(),scenery:GetTypeName()})
        --MESSAGE:New("TARGET VIVO " .. scenery:GetName() .. " - " .. scenery:GetTypeName() .. " - non presente registro", messageTime, nil ):ToLogIf(DEBUGLOG):ToAll() 
      end
    
    else
      local presentDest = false

      for _,v in pairs(sceneryDestroyed[client]) do
      --for _,v in pairs(sceneryDestroyed) do
        if v == scenery:GetName() then
          presentDest = true
          --MESSAGE:New("TARGET DEST " .. scenery:GetName() .. " - " .. scenery:GetTypeName() .. " - già registrato", messageTime, nil ):ToLogIf(DEBUGLOG):ToAll()
          break
        end
      end

      if not presentDest then
        table.insert(sceneryDestroyed[client],scenery:GetName())
        --table.insert(sceneryDestroyed,scenery:GetName())
        --MESSAGE:New("TARGET DEST " .. scenery:GetName() .. " - " .. scenery:GetTypeName() .. " - non presente registro", messageTime, nil ):ToLogIf(DEBUGLOG):ToAll() 

        for _,v in pairs(sceneryTarget[client]) do
        --for _,v in pairs(sceneryTarget) do
          if v[1] == scenery:GetName() then
            trigger.action.setUserFlag("AnsirialLBSceneryDest".. logbookSplitter .. v[2], true)
            --MESSAGE:New("NOME RECUPERATO " .. v[1] .. " - " .. v[2], messageTime, nil ):ToLogIf(DEBUGLOG):ToAll()
            break
          end
        end
      end

    end
  end)
  

end

function getAliveStaticPrefix(prefix)
  local aliveCount = 0
  local aliveStatics = SET_STATIC:New():FilterPrefixes(prefix):FilterOnce()

  aliveStatics:ForEachStatic(function(static)
    if static:IsAlive() == true then aliveCount = aliveCount + 1 end
  end)
  
  return aliveCount
end

function getAliveGroupSpawn(spawn)
  local grp = nil
  if spawn ~= nil then
    grp = spawn:GetFirstAliveGroup()
  end
  return grp
end

function getGroupFromZone(zone,recursive)
  local set = nil
  local group = nil

  if string.find(zone:GetName(), "ISIS") ~= nil then set = RED_TARGET_SET end
  if string.find(zone:GetName(), "COA") ~= nil then set = BLUE_TARGET_SET end

  -- Se nella zona è già presente il gruppo allora ricavalo e procedi, altrimenti crealo con il circondario, ricavalo e procedi
  set:ForEachGroupAnyInZone(zone, function(eachGroup)
    group = eachGroup
  end)

  -- se è null non c'era quindi lo creo
  if group == nil then
    MESSAGE:New("Zona NON popolata, creo gruppo...", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    group = spawnGroup(zone:GetName())
    MESSAGE:New("Gruppo nuovo " .. group:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
  end

  --controlla ricorsivamente l'area circostante...
  if recursive then
    spawnZonesAround(zone)
  end
  return group
end

function spawnGroup(zoneName)
  SpawnZone = ZONE:FindByName(zoneName)
  local grp = nil
  local type = nil
  local side = nil
  local spawn = nil
  local set = nil

  if string.find(zoneName, "Armor") ~= nil then type = "Armor" end
  if string.find(zoneName, "Arty") ~= nil then type = "Arty" end
  if string.find(zoneName, "Base") ~= nil then type = "Base" end

  if string.find(zoneName, "ISIS") ~= nil then side = "red" end
  if string.find(zoneName, "COA") ~= nil then side = "blue" end

  if type == "Armor" and side == "red" then spawn = spawn_RED_ARMOR set = RED_ARMOR_SET end
  if type == "Arty" and side == "red" then spawn = spawn_RED_ARTILLERY set = RED_ARTILLERY_SET end
  if type == "Base" and side == "red" then spawn = spawn_RED_BASE set = RED_BASE_SET end

  if type == "Armor" and side == "blue" then spawn = spawn_BLUE_ARMOR set = BLUE_ARMOR_SET end
  if type == "Arty" and side == "blue" then spawn = spawn_BLUE_ARTILLERY set = BLUE_ARTILLERY_SET end
  if type == "Base" and side == "blue" then spawn = spawn_BLUE_BASE set = BLUE_BASE_SET end

  grp = spawn:SpawnInZone(SpawnZone)
  removeUnitPositions (grp)
  addGroupToTargetSet(grp, side, set)
  return grp
end

function addGroupToTargetSet(grp, side, set)
  if side == "blue" then BLUE_TARGET_SET:AddGroup(grp) end
  if side == "red" then RED_TARGET_SET:AddGroup(grp) end

  -- STORE INFO
  local location = ALL_TOWN_SET:FindNearestObjectFromPointVec2(grp:GetPointVec2())
  local targetInfo = {}
  targetInfo["size"] = #grp:GetUnits()
  targetInfo["type"] = grp:GetDCSDesc(1).displayName
  targetInfo["airbase"] = location
  targetInfo["set"] = set                                          
  targetGroups[grp] = targetInfo                   
  checkIfTargetDestroyed (grp)
end

function spawnZonesAround(zone)
  local coord = zone:GetVec2()

  RED_ARMOR_ZONES:ForEachZone(function(cas_zone) 
    if cas_zone:Get2DDistance(coord) < spawnArea then -- se a meno di X km popolala se non lo è già
      getGroupFromZone(cas_zone,false)
    end
  end)

  RED_ARTY_ZONES:ForEachZone(function(cas_zone) 
    if cas_zone:Get2DDistance(coord) < spawnArea then -- se a meno di X km popolala se non lo è già
      getGroupFromZone(cas_zone,false)
    end
  end)

  RED_BASE_ZONES:ForEachZone(function(cas_zone) 
    if cas_zone:Get2DDistance(coord) < spawnArea then -- se a meno di X km popolala se non lo è già
      getGroupFromZone(cas_zone,false)
    end
  end)

  BLUE_ARMOR_ZONES:ForEachZone(function(cas_zone) 
    if cas_zone:Get2DDistance(coord) < spawnArea then -- se a meno di X km popolala se non lo è già
      getGroupFromZone(cas_zone,false)
    end
  end)
end

function getAliveUnitsSet(set)
  local aliveUnits = 0 
  set:ForEachGroupAlive(function (GROUP)
    aliveUnits = aliveUnits + getAliveUnitsGrp(GROUP)
  end)
  return aliveUnits  
end

function getAliveUnitsAirborn(side)
  local aliveUnits = 0
  for grp,grpInfo in pairs(airGroups) do   
    local grpSide = grpInfo["side"]
    if side == grpSide then 
      aliveUnits = aliveUnits + getAliveUnitsGrp(grp)
    end
  end
  return aliveUnits  
end

function getAirbornGroups(side)
  local airbornGroups = 0
  for grp,grpInfo in pairs(airGroups) do   
    local grpSide = grpInfo["side"]
    if side == grpSide then 
      airbornGroups = airbornGroups + 1
    end
  end
  return airbornGroups  
end

function grpInAir (grp)
  local inAir = true
  local grpUnits = grp:GetUnits()
  if grpUnits ~= nil then
    for i = 1, #grpUnits do
      local Unit = grp:GetUnit( i )
      if not Unit:InAir() then
        inAir = false
      end
    end
  else
   inAir = false  
  end
  return inAir
end

function isAirGroup(target)
  for grp,_ in pairs(airGroups) do
    if grp == target then
      return true
    end
  end
  return false
end

-- TARGET FUNCTIONS
function selectTask(side, client)
  local clientGrp = nil
  if client ~= nil then clientGrp = client:GetGroup() end

  -- SET WEIGHTS
  local weights = {}
  if side == "blue" then
    weights[1] = 0.1*RED_SAM_SET:Count()
    weights[2] = 1*RED_ARMOR_ZONES:Count()
    weights[3] = 1*RED_AIR_DEFENCE_SET:Count()
    weights[4] = 1*RED_ARTY_ZONES:Count()
    weights[5] = 1*RED_CONVOY_C_ZONES:Count()
    weights[6] = 0.1*RED_AIRBASE_SET:Count() -- CAP 
    weights[7] = 1*RED_STRUCTURE_SET:Count()
    weights[8] = 0.2*RED_AIRBASE_SET:Count() -- OCA 
    weights[9] = 0.2*RED_RUNWAY_SET:Count() 
    weights[10] = 1*RED_BASE_ZONES:Count()
    
    MESSAGE:New("RED SAM: ".. RED_SAM_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED ARMOR: ".. RED_ARMOR_ZONES:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED AIRDEF: ".. RED_AIR_DEFENCE_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED ARTY: ".. RED_ARTY_ZONES:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED CONVOY: ".. RED_CONVOY_C_ZONES:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED AIRBASE: ".. RED_AIRBASE_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED STRUCTURE: ".. RED_STRUCTURE_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED RUNWAY: ".. RED_RUNWAY_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("RED BASE: ".. RED_BASE_ZONES:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
  end
  if side == "red" then
    weights[1] = 6*BLUE_SAM_SET:Count()
    weights[2] = 0.5*BLUE_ARMOR_SET:Count()
    weights[3] = 1*BLUE_AIR_DEFENCE_SET:Count()
    weights[4] = 0.5*BLUE_ARTILLERY_SET:Count()
    weights[5] = 0
    weights[6] = 2*BLUE_AIRBASE_SET:Count() -- CAP 
    weights[7] = 0.5*RED_STRUCTURE_SET:Count() 
    weights[8] = 1*BLUE_AIRBASE_SET:Count() -- OCA
    weights[9] = 1*BLUE_RUNWAY_SET:Count()
    weights[10] = 0.5*BLUE_BASE_SET:Count()

    MESSAGE:New("BLUE SAM: ".. BLUE_SAM_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("BLUE ARMOR: ".. BLUE_ARMOR_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("BLUE AIRDEF: ".. BLUE_AIR_DEFENCE_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("BLUE ARTY: ".. BLUE_ARTILLERY_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    --MESSAGE:New("BLUE CONVOY: ".. BLUE_CONVOY_ORIGIN_ZONES:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("BLUE AIRBASE: ".. BLUE_AIRBASE_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("BLUE STRUCTURE: ".. BLUE_STRUCTURE_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("BLUE RUNWAY: ".. BLUE_RUNWAY_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New("BLUE BASE: ".. BLUE_BASE_SET:Count() , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
  end

  if clientGrp == nil then
    weights[5] = 0 -- Convoy solo per client quindi qui disabilitata per AI
  else
    if string.starts(clientGrp:GetName(), "CAP") then
      weights[1] = 0
      weights[2] = 0
      weights[3] = 0
      weights[4] = 0
      weights[5] = 0
      weights[7] = 0
      weights[8] = 0 
      weights[9] = 0
      weights[10] = 0
    end

    if string.starts(clientGrp:GetName(), "SEAD") then
      weights[2] = 0
      weights[4] = 0
      weights[5] = 0
      weights[6] = 0
      weights[7] = 0
      weights[8] = 0
      weights[9] = 0
      weights[10] = 0
    end

    if string.starts(clientGrp:GetName(), "CAS/AI") then
      weights[1] = 0
      weights[3] = 0
      weights[6] = 0
      weights[7] = 0
      weights[8] = 0
      weights[9] = 0
    end

    if string.starts(clientGrp:GetName(), "Strike") then
      weights[1] = 0
      weights[2] = 0
      weights[3] = 0
      weights[4] = 0
      weights[5] = 0
      weights[6] = 0
      weights[10] = 0
    end

  end
     
  -- SUM ALL WEIGHTS
  local totalWeight = 0
  for _, weight in pairs(weights) do
      totalWeight = totalWeight + weight
  end
  
  -- PICK RANDOM TASK
  rand = math.random() * totalWeight
  local task = nil
  for i, weight in pairs(weights) do
      if rand < weight then
          task = tasks[i]
          break
      else
          rand = rand - weight
      end
  end

  MESSAGE:New( "Proposed task: ".. task , messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)  
  
  -- RETURN TASK
  return task
end

function getTarget (side, task, orbitWp)
  local target = nil
  
  if task ~= "CAP" then
    if side == "red" then
      -- Definisco il set di partenza
      local targetSet = nil  
      if task == "SAM"          then targetSet = BLUE_SAM_SET end
      if task == "AIR DEFENCE"  then targetSet = BLUE_AIR_DEFENCE_SET end
      if task == "ARMOR"        then targetSet = BLUE_ARMOR_SET  end
      if task == "ARTILLERY"    then targetSet = BLUE_ARTILLERY_SET end
      if task == "BASE"         then targetSet = BLUE_BASE_SET end
      if task == "STRIKE"       then targetSet = BLUE_STRUCTURE_SET end
      if task == "RUNWAY"       then targetSet = BLUE_RUNWAY_SET end
      if task == "AIRBASE"      then targetSet = BLUE_AIRBASE_SET end
      
      -- Selezione target in base a regole
      target = selectTarget (task, targetSet, spawn_BLUE_TMP_AIR_DEFENCE, airbase, side)

    end
    if side == "blue" then
      -- Definisco il set di partenza
      local targetSet = nil  
      if task == "SAM"          then targetSet = RED_SAM_SET end
      if task == "AIR DEFENCE"  then targetSet = RED_AIR_DEFENCE_SET end
      if task == "ARMOR"        then targetSet = RED_ARMOR_ZONES  end
      if task == "ARTILLERY"    then targetSet = RED_ARTY_ZONES end
      if task == "BASE"         then targetSet = RED_BASE_ZONES end
      if task == "STRIKE"       then targetSet = RED_STRUCTURE_SET end
      if task == "RUNWAY"       then targetSet = RED_RUNWAY_SET end
      if task == "AIRBASE"      then targetSet = RED_AIRBASE_SET end
      
      -- Selezione target in base a regole
      target = selectTarget (task, targetSet, spawn_RED_TMP_AIR_DEFENCE, orbitWp, side)
    end
  end

  return target
end

function selectTarget (task, targetSet, airDefenceSpawn, orbitWp, side)
  local target = nil
  local opfor = nil
  local aliveUnits = 0
  local attempts = targetSearchAttempts
  local minAliveUnits = 5
  local riskLimit = 1
  if side == "red" then opfor = "blue" end
  if side == "blue" then opfor = "red" end

  local removed = {}

  if task == "STRIKE" or task == "RUNWAY" or task == "AIRBASE" then
    while isTargetBooked(task,target) and attempts > 0 do

      target = targetSet:GetRandomSurely()

      while target:GetCoordinate():Get2DDistance(orbitWp:GetCoordinate()) > maxTargetDistance * 1000 do
        target = targetSet:GetRandomSurely()
      end
      attempts = attempts - 1

      if attempts == 0 then
        attempts = targetSearchAttempts
        riskLimit = riskLimit + 1
      end
    end

    if task == "STRIKE" then
      -- GENERATE AIR DEFENCE FOR TARGET
      local grp = airDefenceSpawn:SpawnFromVec2(target:GetVec2())
      removeUnitPositions (grp)

      --if side == "blue" then RED_TARGET_SET:AddGroup(grp) end
      --if side == "red" then BLUE_TARGET_SET:AddGroup(grp) end
      MESSAGE:New( "Generating air defence " .. grp:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
      -- occhio che si rischia di generarli doppi...
    end
    bookTarget (task,target)
    return target
  end

  if task == "ARMOR" or task == "ARTILLERY" or task == "BASE" then
    targetGroup = nil
    set = nil
    while (isTargetBooked(task,targetGroup) or aliveUnits < minAliveUnits) and attempts > 0 and minAliveUnits > 0 do
      if target ~= nil then
        table.insert(removed, target:GetName())
        targetSet:RemoveZonesByName({target:GetName()})
      end

      target = targetSet:GetRandomSurely()

      while target:GetCoordinate():Get2DDistance(orbitWp:GetCoordinate()) > maxTargetDistance * 1000 do
        target = targetSet:GetRandomSurely()
      end

      -- Se nella zona è già presente il gruppo allora ricavalo e procedi, altrimenti crealo con il circondario, ricavalo e procedi
      targetGroup = getGroupFromZone(target,true)
      
      if targetGroup ~= nil then
        aliveUnits = getAliveUnitsGrp(targetGroup)
        attempts = attempts - 1
      else
        targetSet:AddZonesByName(removed)
        attempts = targetSearchAttempts
        aliveUnits = 0
        minAliveUnits = minAliveUnits - 1
        riskLimit = riskLimit + 1
      end
      
      MESSAGE:New("Looking for target... Found " .. target:GetName() .. " (" .. targetGroup:GetName() .. ")" .. " -> with " .. aliveUnits .. " units - " .. attempts .. " attepts left", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    end
    targetSet:AddZonesByName(removed)
    bookTarget (task,targetGroup)
    return targetGroup
  else
    while (isTargetBooked(task,target) or aliveUnits < minAliveUnits) and attempts > 0 and minAliveUnits > 0 do
      if target ~= nil then
        table.insert(removed, target:GetName())
        targetSet:RemoveGroupsByName({target:GetName()})
      end

      target = targetSet:GetRandomSurely()

      while target:GetCoordinate():Get2DDistance(orbitWp:GetCoordinate()) > maxTargetDistance * 1000 do
        target = targetSet:GetRandomSurely()
      end

      if target ~= nil then
        aliveUnits = getAliveUnitsGrp(target)
        attempts = attempts - 1
      else
        targetSet:AddGroupsByName(removed)
        attempts = targetSearchAttempts
        aliveUnits = 0
        minAliveUnits = minAliveUnits - 1
        riskLimit = riskLimit + 1
      end
      
      MESSAGE:New("Looking for target... Found " .. target:GetName() .. " -> with " .. aliveUnits .. " units - " .. attempts .. " attepts left", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    end
    targetSet:AddGroupsByName(removed)
    bookTarget (task,target)
    return target
  end
end

function isTargetBooked(task,target)
  if target ~= nil then
    for k,v in ipairs(BOOKED_TARGETS) do
      if v == task .. "-" .. target:GetName() then
        return true
      end
    end
    return false
  else
    return true
  end
end

function bookTarget (task,target)
  if task ~= "CONVOY" and target ~= nil then
    table.insert(BOOKED_TARGETS,task .. "-" .. target:GetName())
  end

  if DEBUG or DEBUGLOG then
    for k,v in ipairs(BOOKED_TARGETS) do
      MESSAGE:New("BOOKED TARGETS " .. k .. " " .. v, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    end
  end

end

function freeTarget (task,target)
  if task ~= "CONVOY" and target ~= nil then
    MESSAGE:New("CLEANING: " .. task .. "-" .. target:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    local index = 0

    for k,v in ipairs(BOOKED_TARGETS) do
      if v == task .. "-" .. target:GetName() then
        index = k
        break
      end
    end

    if index ~= 0 then
      table.remove(BOOKED_TARGETS,index)
    end
  end
end

-- AI TASK FUNCTIONS
function taskGroundAttack(grp)

  -- RETRIEVE GRP INFO
  local grpInfo = airGroups[grp]
  local grpSide = grpInfo["side"]
  local grpTask = grpInfo["task"]
  local grpAirbase = grpInfo["airbase"]
  local grpTarget = grpInfo["target"]
  local grpType = grpInfo["type"]
    
  -- RETRIEVE TARGET INFO
  local targetInfo = targetGroups[grpTarget]
  --local targetSize = targetInfo["size"]
  --local targetType = targetInfo["type"]
  --local targetAirbase = targetInfo["airbase"]  

  -- MESSAGE
  --local unitMessage = " unit at "
  --if targetSize > 1 then unitMessage = " units at " end

  --local dispatchString = " \nAIR COMMAND\n"
  --if grpTask == "SAM"          then dispatchString = dispatchString .. "Task: Suppression of Enemy Air Defenses\n" end
  --if grpTask == "AIR DEFENCE"  then dispatchString = dispatchString .. "Task: Suppression of Enemy Air Defenses\n" end
  --if grpTask == "ARMOR"        then dispatchString = dispatchString .. "Task: Close Air Support\n" end
  --if grpTask == "ARTILLERY"    then dispatchString = dispatchString .. "Task: Close Air Support\n" end
  --if grpTask == "SUPPORT"      then dispatchString = dispatchString .. "Task: Close Air Support\n" end 
  --if grpTask == "BAI"          then dispatchString = dispatchString .. "Task: Battlefield Air interdiction\n" end 
  --if grpTask == "STRIKE"       then dispatchString = dispatchString .. "Task: Deep Strike\n" end 
  --dispatchString = dispatchString .. "Airframe: " .. grpType .. "\n"
  --dispatchString = dispatchString .. "Depart from: " .. grpAirbase:GetName() .. "\n"
  --dispatchString = dispatchString .. "Target: " .. targetSize .. " " .. targetType .. unitMessage .. targetAirbase:GetName():gsub("Geo ", "") .. "\n"
  --dispatchString = dispatchString .. "Type: " .. grpTask .. "\n "   
  --sendInfo (dispatchString,grpSide,messageTime)
    
  -- ROUTE
  local EngageRoute = {}
  
  -- SPEED & ALTITUDE
  local RouteAltitude = math.random( minSpawnAltitudeMeters, maxSpawnAltitudeMeters ) -- metri
  local RouteSpeed = math.random( 650, 740 )  

  -- ATTACK GROUP
  local AttackTasks = {}

  if grpTask == "STRIKE" or grpTask == "RUNWAY"  or grpTask == "AIRBASE" then

    if grpTask == "STRIKE" then
      local aliveStructures = SET_SCENERY:NewFromZone(grpTarget):FilterOnce()

      aliveStructures:ForEachScenery(function(scenery)
        if not scenery:IsAlive() then
          aliveStructures:Remove(scenery:GetName())
        end
      end)
      
      local coords = aliveStructures:GetRandom():GetVec2()
      AttackTasks[1] = grp:TaskBombing(coords,false)
    end

    if grpTask == "RUNWAY" then
      local coords = grpTarget:GetVec2()
      AttackTasks[1] = grp:TaskBombing(coords,true,AI.Task.WeaponExpend.ALL)
    end

    if grpTask == "AIRBASE" then
      local target_set = SET_STATIC:New()
      :FilterPrefixes(grpTarget:GetName())
      :FilterOnce()

      attackIndex = 1

      target_set:ForEachStatic(function(STATIC)
        AttackTasks[attackIndex] = grp:TaskAttackUnit(STATIC, false)
        attackIndex = attackIndex + 1
      end)
    end

  else
    local coords = grpTarget:GetVec2()
    AttackTasks[1] = grp:TaskAttackGroup(grpTarget)

    --local AttackUnits = grpTarget:GetUnits()  
    --for i = 1, #AttackUnits do
    --  local AttackUnit = grpTarget:GetUnit( i )
    --  AttackTasks[#AttackTasks+1] = grp:TaskAttackUnit( AttackUnit,true)
    --end
  end
  
   -- CURRENT
  local grpVec2 = grp:GetVec2()
  local grpPointVec3 = POINT_VEC3:New( grpVec2.x, RouteAltitude, grpVec2.y )
  local grpRoutePoint = grpPointVec3:WaypointAir( 
    "RADIO", 
    COORDINATE.WaypointType.TurningPoint, 
    COORDINATE.WaypointAction.TurningPoint, 
    RouteSpeed, 
    true,
    grpAirbase,
    nil,
    "TAKEOFF"
  ) 
  EngageRoute[#EngageRoute+1] = grpRoutePoint 

  -- IP
  local IPVec2 = nil

  if grpAirbase:GetName() == "Muwaffaq Salti" then
    IPVec2 = ZONE:FindByName("blueZone3"):GetVec2()
  else
    IPVec2 = ZONE:FindByName("blueZone1"):GetVec2()
  end

  local IPPointVec3 = POINT_VEC3:New( IPVec2.x, RouteAltitude, IPVec2.y )
  local IPRoutePoint = IPPointVec3:WaypointAir( 
    "RADIO", 
    COORDINATE.WaypointType.TurningPoint, 
    COORDINATE.WaypointAction.TurningPoint, 
    RouteSpeed, 
    true,
    grpAirbase,
    nil,
    "IP"
  ) 
  EngageRoute[#EngageRoute+1] = IPRoutePoint 

  -- TARGET
  local TargetVec2 = grpTarget:GetVec2()
  local TargetPointVec3 = POINT_VEC3:New( TargetVec2.x, RouteAltitude, TargetVec2.y )
  local TargetRoutePoint = TargetPointVec3:WaypointAir( 
    "RADIO", 
    COORDINATE.WaypointType.TurningPoint, 
    COORDINATE.WaypointAction.TurningPoint, 
    RouteSpeed, 
    true,
    grpAirbase,
    AttackTasks,
    "TARGET"
  ) 
  EngageRoute[#EngageRoute+1] = TargetRoutePoint 

  -- EGRESS
  local EgressVec2 = POINT_VEC3:New( IPVec2.x, RouteAltitude, IPVec2.y )
  local EgressPointVec3 = POINT_VEC3:New( EgressVec2.x, RouteAltitude, EgressVec2.y )
  local EgressRoutePoint = IPPointVec3:WaypointAir( 
    "RADIO", 
    COORDINATE.WaypointType.TurningPoint, 
    COORDINATE.WaypointAction.TurningPoint, 
    RouteSpeed, 
    true,
    grpAirbase,
    nil,
    "EGRESS"
  ) 
  EngageRoute[#EngageRoute+1] = EgressRoutePoint 

   -- AIRBASE
  local airbaseVec2 = grpAirbase:GetVec2()
  local airbasePointVec3 = POINT_VEC3:New( airbaseVec2.x, RouteAltitude, airbaseVec2.y )
  local airbaseRoutePoint = airbasePointVec3:WaypointAir( 
    "RADIO", 
    COORDINATE.WaypointType.Land, 
    COORDINATE.WaypointAction.Landing, 
    RouteSpeed, 
    false,
    grpAirbase,
    nil,
    "LAND"
  ) 
  EngageRoute[#EngageRoute+1] = airbaseRoutePoint 
  
  grp:Route( EngageRoute, 1 )
  grp:OptionROE(ENUMS.ROE.OpenFire)
  grp:OptionROT(ENUMS.ROT.BypassAndEscape)
  grp:OptionRestrictBurner(true)  

end

function taskCAP (grp)

  -- RETRIEVE GRP INFO
  local grpInfo = airGroups[grp]
  local grpSide = grpInfo["side"]
  local grpTask = grpInfo["task"]
  local grpAirbase = grpInfo["airbase"]
  local grpTarget = grpInfo["target"]  
  local grpType = grpInfo["type"]
  
  -- TASK
  local grpUnits = #grp:GetUnits()
  if grpSide == "blue" then  
    local AI_CAP = AI_CAP_ZONE:New(BLUE_CAP_ZONE, minSpawnAltitudeMeters, maxSpawnAltitudeMeters, 500, 1200)
    AI_CAP:SetControllable(grp)
    AI_CAP:SetEngageZone(BLUE_CAP_ZONE) -- Set the Engage Zone. The AI will only engage when the bogeys are within the CapEngageZone.
    AI_CAP:__Start( 1 )
    grp:OptionProhibitAfterburner(true)  
  end
  if grpSide == "red" then  
    --local AI_CAP = AI_CAP_ZONE:New( RED_CAP_ZONE, 5000, 10000, 500, 1200 )
    --AI_CAP:SetControllable( grp )
    --AI_CAP:__Start( 1 )
  end 
  
  -- MESSAGE 
  local dispatchString = " \nAIR COMMAND\n"
  dispatchString = dispatchString .. "Task: Combat Air Patrol\n"
  dispatchString = dispatchString .. "Airframe: " .. grpType .. "\n"   
  dispatchString = dispatchString .. "Depart from: " .. grpAirbase:GetName() .. "\n "
  --sendInfo (dispatchString,grpSide,messageTime)
     
end

-- FLIGHT FUNCTIONS
function checkForTakeoff (grp)
  if grp:IsAlive() then
    -- RETRIEVE GRP INFO
    local grpInfo = airGroups[grp]
    local grpSide = grpInfo["side"]
    local grpTask = grpInfo["task"]
    local grpAirbase = grpInfo["airbase"]
    local grpTarget = grpInfo["target"]     
    local grpType = grpInfo["type"]
    if grpInAir(grp) then      
      if grpTask == "SAM" or grpTask == "AIR DEFENCE" then   
        SCHEDULER:New( nil, function () sendInfo (grpType .. " SEAD flight has departed from " .. grpAirbase:GetName(),grpSide,messageTime) end,{},6) 
      end
      if grpTask == "ARMOR" or grpTask == "ARTILLERY" then 
        SCHEDULER:New( nil, function () sendInfo (grpType .. " CAS flight has departed from " .. grpAirbase:GetName(),grpSide,messageTime) end,{},6)
      end
      if grpTask == "AIRBASE" or grpTask == "RUNWAY" then 
        SCHEDULER:New( nil, function () sendInfo (grpType .. " OCA flight has departed from " .. grpAirbase:GetName(),grpSide,messageTime) end,{},6)
      end    
      if grpTask == "CONVOY" then
        SCHEDULER:New( nil, function () sendInfo (grpType .. " AI flight has departed from " .. grpAirbase:GetName(),grpSide,messageTime) end,{},6)
      end  
      if grpTask == "STRIKE" or grpTask == "BASE" then
        SCHEDULER:New( nil, function () sendInfo (grpType .. " STRIKE flight has departed from " .. grpAirbase:GetName(),grpSide,messageTime) end,{},6)
      end     
      if grpTask == "CAP" then
        SCHEDULER:New( nil, function () sendInfo (grpType .. " CAP flight has departed from " .. grpAirbase:GetName(),grpSide,messageTime) end,{},6)
      end

      if grpSide == "blue" then 
        SCHEDULER:New( nil, function () sendInfo ("Be advised! Enemy activity has been detected from " .. grpAirbase:GetName(),"red",messageTime) end,{},6) 
      end
      if grpSide == "red" then
         SCHEDULER:New( nil, function () sendInfo ("Be advised! Enemy activity has been detected from " .. grpAirbase:GetName(),"blue",messageTime) end,{},6) 
      end
    else
      SCHEDULER:New( nil, checkForTakeoff, {grp}, 10 ) 
    end
  end
end

function cleanupUnit (unit, grp, vec2)
  if unit:IsAlive() then
    local newVec2 = unit:GetVec2()
    if unit:InAir() == false and unit:GetVelocityKMH() < 1 then
      if newVec2.x == vec2.x and newVec2.y == vec2.y then
        unit:Destroy()
        MESSAGE:New( unit:GetName() .. " is removed by cleanup script", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
        SCHEDULER:New( nil, function()     
          if grp:IsAlive() then
            MESSAGE:New( grp:GetName() .. " is still alive", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)  
          else
            airGroups[grp] = nil          
          end       
        end , {}, 1 )          
      else
        SCHEDULER:New( nil, cleanupUnit, {unit, grp, newVec2}, cleanupInterval )     
      end
    else
      SCHEDULER:New( nil, cleanupUnit, {unit, grp, newVec2}, cleanupInterval )    
    end
  end
end

function addHandlers (grp)

  -- RETRIEVE GRP INFO
  local grpInfo = airGroups[grp]
  local side = grpInfo["side"]
  local task = grpInfo["task"]
  local airbase = grpInfo["airbase"]
  local target = grpInfo["target"]                                       
  
  local grpUnits = grp:GetUnits()
  for i = 1, #grpUnits do
    local Unit = grp:GetUnit( i )
  
    -- IF CHRASHED      
    Unit:HandleEvent(EVENTS.Crash)
    function Unit:OnEventCrash( EventData )   
      if side == "blue" then 
        aircraftBLUE = aircraftBLUE - 1 
        sendInfo (bluePlayers .. " plane has been lost","all",messageTime)
      end  
      if side == "red"  then
         aircraftRED = aircraftRED - 1 
         sendInfo (redPlayers .. " plane has been lost","all",messageTime)
      end               
      SCHEDULER:New( nil, function()     
        if grp:IsAlive() then
          MESSAGE:New( grp:GetName() .. " is still alive", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)  
        else
          MESSAGE:New( grp:GetName() .. " has been destroyed", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
          airGroups[grp] = nil                 
        end       
      end , {}, 1 )           
    end
    
      --IF LANDED
      Unit:HandleEvent(EVENTS.Land)    
      function Unit:OnEventLand( EventData )
        sendInfo (grp:GetUnit(1):GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat") .. " has landed at " .. EventData.PlaceName,side,messageTime)
        if despawnType == "LAND" then Unit:Destroy() end     
        SCHEDULER:New( nil, function()     
          if grp:IsAlive() then
            MESSAGE:New( grp:GetName() .. " is still alive", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)  
          else
            airGroups[grp] = nil          
          end       
        end , {}, 1 )           
      end

      -- IF ENGINE SHUTDOWN
      Unit:HandleEvent(EVENTS.EngineShutdown)    
      function Unit:OnEventEngineShutdown( EventData )
        if not Unit:InAir() then
          if despawnType == "SHUTDOWN" then Unit:Destroy() end
          SCHEDULER:New( nil, function()     
            if grp:IsAlive() then
              MESSAGE:New( grp:GetName() .. " is still alive", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)  
            else
              airGroups[grp] = nil                   
            end       
          end , {}, 1 )
        end 
      end

    -- IF STUCK
    local vec2 = Unit:GetVec2()
    SCHEDULER:New( nil, cleanupUnit, {Unit, grp, vec2}, cleanupInterval ) 
    
  end
end

function dispatcher(side, immediateSpawnZone)

  if initMission then
    if immediateSpawnZone == nil then
      SCHEDULER:New( nil, dispatcher, {side, immediateSpawnZone}, math.random(minDispatchTime,maxDispatchTime) )
    end   

    -- SELECT RED SIDE
    if side == "red" then
      MESSAGE:New( "Generating RED", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
      -- CHECK SQUADRONS  
      if (aircraftRED - getAliveUnitsAirborn(side)) > 1 then
  
        -- SELECT TASK
        local task = selectTask(side, nil)
        if immediateSpawnZone == "redCapZone" then task = "CAP" end

        if task ~= nil then
      
          -- CHECK AIRBORNE
          if (getAirbornGroups(side) < 2*RED_AIRBASE_SET:Count() and getAirbornGroups(side) < maxAirborneRed) then
            
            -- CHECK FOR AIRBASES 
            if RED_AIRBASE_SET:Count()>0 then
          
              -- SELECT AIRBASE
              local airbase = RED_AIRBASE_SET:GetRandomAirbase()

              -- SELECT TARGET
              local target = getTarget (side, task, airbase)
                                   
              -- SELECT SPAWN
              local spawnSet = nil         
              --if task == "SAM"          then spawnSet = spawn_RED_SEAD end
              --if task == "AIR DEFENCE"  then spawnSet = spawn_RED_SEAD end
              if task == "ARMOR"        then spawnSet = spawn_RED_CAS end
              if task == "ARTILLERY"    then spawnSet = spawn_RED_CAS end
              if task == "CONVOY"      then spawnSet = spawn_RED_CAS end
              if task == "BASE"          then spawnSet = spawn_RED_CAS end
              if task == "STRIKE"       then spawnSet = spawn_RED_CAS end
              if task == "RUNWAY"       then spawnSet = spawn_RED_CAS end
              if task == "AIRBASE"       then spawnSet = spawn_RED_CAS end
              if task == "CAP"          then spawnSet = spawn_RED_CAP end
              
              MESSAGE:New( "Generating RED" .. " " .. task, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
              -- SPAWN GROUP
              local grp = nil

              if immediateSpawnZone ~= nil then
                local SpawnZone = ZONE:New(immediateSpawnZone)
                grp = spawnSet:SpawnInZone(SpawnZone,true, minSpawnAltitudeMeters, maxSpawnAltitudeMeters)
                MESSAGE:New( "Generating RED in " .. immediateSpawnZone, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
              else
                grp = spawnSet:SpawnAtAirbase(airbase,spawnType, nil, AIRBASE.TerminalType.OpenBig, true)
              end
              
              -- STORE INFO
              local grpInfo = {}
              grpInfo["side"] = side
              grpInfo["task"] = task
              grpInfo["airbase"] = airbase                                         
              grpInfo["target"] = target
              grpInfo["type"] = grp:GetUnit(1):GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet") 
              airGroups[grp] = grpInfo
                            
              -- IF SPAWNED
              grp:HandleEvent(EVENTS.Birth)
              function grp:OnEventBirth( EventData )
                local spawnedUnit = EventData.IniUnit
                if spawnedUnit == grp:GetUnit(1) then
                            
                  -- SET TASK
                  if task == "CAP" then         
                    SCHEDULER:New( nil, taskCAP, {grp}, 1 )                  
                  else
                    SCHEDULER:New( nil, taskGroundAttack, {grp}, 1 )          
                  end
            
                  -- CHECK TAKEOFF
                  SCHEDULER:New( nil, checkForTakeoff, {grp}, 1 )
          
                -- ADD HANDLERS
                  SCHEDULER:New( nil, addHandlers, {grp}, 1 )  
                                      
                end
              end                           
            else
              MESSAGE:New( side .. " HAS NO MORE AIRBASES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
            end
          else
            MESSAGE:New( side .. " HAS TOO MANY PLANES AIRBORNE", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)      
          end
        else
          MESSAGE:New( side .. " HAS NO MORE TASKS", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
        end
      else
        MESSAGE:New( side .. " HAS NO MORE AIRCRAFT", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
      end     
    end
  
    -- SELECT BLUE SIDE
    if side == "blue" then
      MESSAGE:New( "Generating BLUE", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
      -- CHECK SQUADRONS  
      if (aircraftBLUE - getAliveUnitsAirborn(side)) > 1 then
      
        -- SELECT TASK
        local task = selectTask(side, nil)
        if immediateSpawnZone == "blueCapZone" then task = "CAP" end

        if task ~= nil then
          -- CHECK AIRBORNE
          if (getAirbornGroups(side) < maxAirborneBlue) then
            
            -- CHECK FOR AIRBASES 
            if BLUE_AIRBASE_SET:Count()>0 then
          
              -- SELECT AIRBASE, ne prendo una a caso, poi eventualmente sovrascrivo
              local airbase = BLUE_AIRBASE_SET:GetRandomAirbase()

              if immediateSpawnZone ~= nil then
                while airbase:GetName() == "Muwaffaq Salti" do
                  airbase = BLUE_AIRBASE_SET:GetRandomAirbase()
                end
              end

              while airbase:GetName() == "Kiryat Shmona" or airbase:GetName() == "Eyn Shemer" or airbase:GetName() == "Rosh Pina" or airbase:GetName() == "Megiddo" do
              --while airbase:GetName() ~= "CVN-71 Theodore Roosevelt" do
                airbase = BLUE_AIRBASE_SET:GetRandomAirbase()
              end

              -- SELECT TARGET
              local target = getTarget (side, task, airbase)
                                   
              -- SELECT SPAWN
              local spawnSet = nil         
              if task == "SAM" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"         then spawnSet = spawn_BLUE_SEAD end
              if task == "AIR DEFENCE" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt" then spawnSet = spawn_BLUE_SEAD end
              if task == "ARMOR" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"       then spawnSet = spawn_BLUE_CAS end
              if task == "ARTILLERY" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"   then spawnSet = spawn_BLUE_CAS end
              if task == "CONVOY" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"      then spawnSet = spawn_BLUE_CAS end
              if task == "BASE" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"        then spawnSet = spawn_BLUE_CAS end
              if task == "STRIKE" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"      then spawnSet = spawn_BLUE_CAS end
              if task == "RUNWAY" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"      then spawnSet = spawn_BLUE_CAS end
              if task == "AIRBASE" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"     then spawnSet = spawn_BLUE_CAS end
              if task == "CAP" and airbase:GetName() ~= "CVN-71 Theodore Roosevelt"         then spawnSet = spawn_BLUE_CAP end

              if task == "SAM" and airbase:GetName() == "CVN-71 Theodore Roosevelt"         then spawnSet = spawn_BLUE_SEAD_CVN end
              if task == "AIR DEFENCE" and airbase:GetName() == "CVN-71 Theodore Roosevelt" then spawnSet = spawn_BLUE_SEAD_CVN end
              if task == "ARMOR" and airbase:GetName() == "CVN-71 Theodore Roosevelt"       then spawnSet = spawn_BLUE_CAS_CVN end
              if task == "ARTILLERY" and airbase:GetName() == "CVN-71 Theodore Roosevelt"   then spawnSet = spawn_BLUE_CAS_CVN end
              if task == "CONVOY" and airbase:GetName() == "CVN-71 Theodore Roosevelt"      then spawnSet = spawn_BLUE_CAS_CVN end
              if task == "BASE" and airbase:GetName() == "CVN-71 Theodore Roosevelt"        then spawnSet = spawn_BLUE_CAS_CVN end
              if task == "STRIKE" and airbase:GetName() == "CVN-71 Theodore Roosevelt"      then spawnSet = spawn_BLUE_CAS_CVN end
              if task == "RUNWAY" and airbase:GetName() == "CVN-71 Theodore Roosevelt"      then spawnSet = spawn_BLUE_CAS_CVN end
              if task == "AIRBASE" and airbase:GetName() == "CVN-71 Theodore Roosevelt"     then spawnSet = spawn_BLUE_CAS_CVN end
              if task == "CAP" and airbase:GetName() == "CVN-71 Theodore Roosevelt"         then spawnSet = spawn_BLUE_CAP_CVN end
                                           
              -- SPAWN GROUP
              local grp = nil

              if immediateSpawnZone ~= nil then
                local SpawnZone = ZONE:New(immediateSpawnZone)
                grp = spawnSet:SpawnInZone(SpawnZone,true, 2000, 4000)
                MESSAGE:New( "Generating BLUE in " .. immediateSpawnZone, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
              else
                if airbase:GetName() == "CVN-71 Theodore Roosevelt" then
                  grp = spawnSet:SpawnAtAirbase(airbase,spawnTypeCVN, nil, nil, true)
                else
                  grp = spawnSet:SpawnAtAirbase(airbase,spawnType, nil, AIRBASE.TerminalType.OpenBig, true)
                end
              end

              -- STORE INFO
              local grpInfo = {}
              grpInfo["side"] = side
              grpInfo["task"] = task
              grpInfo["airbase"] = airbase                                         
              grpInfo["target"] = target
              grpInfo["type"] = grp:GetUnit(1):GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat") 
              airGroups[grp] = grpInfo

              -- IF SPAWNED
              grp:HandleEvent(EVENTS.Birth)
              function grp:OnEventBirth( EventData )
                local spawnedUnit = EventData.IniUnit
                if spawnedUnit == grp:GetUnit(1) then
                            
                  -- SET TASK
                  if task == "CAP" then         
                    SCHEDULER:New( nil, taskCAP, {grp}, 1 )                  
                  else
                    SCHEDULER:New( nil, taskGroundAttack, {grp}, 1 )          
                  end
            
                  -- CHECK TAKEOFF
                  SCHEDULER:New( nil, checkForTakeoff, {grp}, 1 )
                           
                  -- ADD HANDLERS
                  SCHEDULER:New( nil, addHandlers, {grp}, 1 )  
                    
                end
              end                           
            else
              MESSAGE:New( side .. " HAS NO MORE AIRBASES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
            end
          else
            MESSAGE:New( side .. " HAS TOO MANY PLANES AIRBORNE", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)      
          end
        else
          MESSAGE:New( side .. " HAS NO MORE TASKS", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
        end
      else
        MESSAGE:New( side .. " HAS NO MORE AIRCRAFT", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
      end      
    end
  else
    SCHEDULER:New( nil, dispatcher, {side, immediateSpawnZone}, 1 )  
  end 
end

-- TARGET SAVE FUNCTIONS
function saveTargetData (set)

  set:ForEachGroup(function(GROUP)
    if GROUP:IsAlive() then
      --cambiato per trovare la vicinanza con la città
      local airbase = ALL_TOWN_SET:FindNearestObjectFromPointVec2(GROUP:GetPointVec2())
      
      if GROUP:GetCoalition() == 1 then RED_TARGET_SET:AddGroup(GROUP) end
      if GROUP:GetCoalition() == 2 then BLUE_TARGET_SET:AddGroup(GROUP) end

      -- STORE INFO
      local targetInfo = {}
      targetInfo["size"] = #GROUP:GetUnits()
      targetInfo["type"] = GROUP:GetDCSDesc(1).displayName
      targetInfo["airbase"] = airbase
      targetInfo["set"] = set                                          
      targetGroups[GROUP] = targetInfo
                                            
      checkIfTargetDestroyed (GROUP)
    else
      set:RemoveGroupsByName({GROUP:GetName()})
    end
  end)
  initCount = initCount + 1
  MESSAGE:New( "InitCount: " .. initCount, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  if initCount == 10 then initMission = true end
end

-- Non in uso qui
function saveStructureData (set)
  set:ForEachZone(function(ZONE)                  
    if getAliveStructuresZone(ZONE) == 0 then
      set:RemoveZonesByName(ZONE:GetName())
      MESSAGE:New( "Removing structure zone " .. ZONE:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
    end
  end)
end

function checkIfTargetDestroyed (target)
  if target:IsAlive() then
    SCHEDULER:New( nil, checkIfTargetDestroyed, {target}, 10 )
  else
    -- RETRIEVE TARGET INFO
    local targetInfo = targetGroups[target]
    local size = targetInfo["size"]
    local type = targetInfo["type"]
    local airbase = targetInfo["airbase"] 
    local set = targetInfo["set"]
         
    -- MSG
    -- if size > 1 then
    --   sendInfo (size .. " " .. type .. " units have been destroyed at " .. airbase:GetName(),"all",messageTime)      
    -- else
    --  sendInfo (size .. " " .. type .. " unit has been destroyed at " .. airbase:GetName(),"all",messageTime)    
    -- end
      
    -- REMOVE FROM SETS
    targetGroups[target] = nil
    set:RemoveGroupsByName({target:GetName()})
    if target:GetCoalition() == 1 then RED_TARGET_SET:RemoveGroupsByName({target:GetName()}) end
    if target:GetCoalition() == 2 then BLUE_TARGET_SET:RemoveGroupsByName({target:GetName()}) end   
  end
end

-- per ora deprecata
function checkAirbases(side)
  if initMission then
    if side == "red" then
      if RED_AIRBASE_SET:Count()>0 then
        RED_AIRBASE_SET:ForEachAirbase(function(AIRBASE)
          local operational = false          
          for target,targetInfo in pairs(targetGroups) do       
            local airbase = targetInfo["airbase"]
            if AIRBASE == airbase then 
              operational = true
            end
          end        
          if operational then
            -- STILL UNITS IN AREA
          else
            RED_AIRBASE_SET:RemoveAirbasesByName({AIRBASE:GetName()})
            sendInfo ("Airbase " .. AIRBASE:GetName() .. " is no longer operational","all",messageTime)
            AIRBASE:GetCoordinate():BigSmokeHuge(0.5)
          end
          
        end)
        SCHEDULER:New( nil, checkAirbases, {side}, 10 )
      else
        sendInfo (redFaction .. " no longer has any operational airbase","all",targetTime)    
      end    
    end 
    if side == "blue" then 
      if BLUE_AIRBASE_SET:Count()>0 then
        BLUE_AIRBASE_SET:ForEachAirbase(function(AIRBASE)
          local operational = false          
          for target,targetInfo in pairs(targetGroups) do       
            local airbase = targetInfo["airbase"]
            if AIRBASE == airbase then 
              operational = true
            end
          end        
          if operational then
            -- STILL UNITS IN AREA
          else
            BLUE_AIRBASE_SET:RemoveAirbasesByName({AIRBASE:GetName()})
            sendInfo ("Airbase " .. AIRBASE:GetName() .. " is no longer operational","all",messageTime)
            AIRBASE:GetCoordinate():BigSmokeHuge(0.5)
          end
        end)
        SCHEDULER:New( nil, checkAirbases, {side}, 10 )
      else
        sendInfo (blueFaction .. " no longer has any operational airbase","all",targetTime)    
      end    
    end 
  else
    SCHEDULER:New( nil, checkAirbases, {side}, 1 )  
  end 
end 

-- TANKER FUNCTIONS
function spawnTanker(spawn,side)
  if initMission then
    if side == "blue" then
      if BLUE_AIRBASE_SET:Count()>0 then  
        local airbase = BLUE_AIRBASE_SET:GetRandomAirbase()
        local grp = spawn:SpawnAtAirbase(airbase,spawnType, nil, AIRBASE.TerminalType.OpenBig, true)
        
        -- IF SPAWNED
        grp:HandleEvent(EVENTS.Birth)
        function grp:OnEventBirth( EventData )
          local spawnedUnit = EventData.IniUnit
          if spawnedUnit == grp:GetUnit(1) then
                                
            -- CHECK FOR RESPAWN
            SCHEDULER:New( nil, respawnTanker, {grp,spawn,side}, 1 )  
              
            -- ADD HANDLERS
            local grpUnits = grp:GetUnits()
            for i = 1, #grpUnits do
              local Unit = grp:GetUnit( i )

              -- IF TAKEOFF      
              Unit:HandleEvent(EVENTS.Takeoff)
              function Unit:OnEventTakeoff( EventData )
                sendInfo (Unit:GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat")  .. " TANKER has departed from " .. EventData.PlaceName,side,messageTime)       
              end
                          
              -- IF CHRASHED      
              Unit:HandleEvent(EVENTS.Crash)
              function Unit:OnEventCrash( EventData )
                sendInfo (Unit:GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat")  .. " TANKER has been killed","all",messageTime)      
              end
   
              --IF LANDED             
              Unit:HandleEvent(EVENTS.Land)
              function Unit:OnEventLand( EventData )
                if despawnType == "LAND" then Unit:Destroy() end
              end
              
              -- IF ENGINE SHUTDOWN                                   
              Unit:HandleEvent(EVENTS.EngineShutdown)
              function Unit:OnEventEngineShutdown( EventData )
                if not Unit:InAir() then
                  if despawnType == "SHUTDOWN" then Unit:Destroy() end
                end
              end
  
              -- IF STUCK
              local vec2 = Unit:GetVec2()
              SCHEDULER:New( nil, cleanupUnit, {Unit, grp, vec2}, cleanupInterval ) 
              
            end           
          end
        end            
      else
        MESSAGE:New( side .. " HAS NO MORE AIRBASES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
      end
    end
  else
    SCHEDULER:New( nil, spawnTanker, {spawn,side}, 1 )  
  end 
end

function respawnTanker (grp,spawn,side)  
  if grp:IsAlive() then
    SCHEDULER:New( nil, respawnTanker, {grp,spawn,side}, 10 )    
  else
    spawnTanker(spawn,side)
  end 
end
-- AWACS FUNCTIONS
function spawnAwacs(side)
  if initMission then
    if side == "blue" then
      if BLUE_AIRBASE_SET:Count()>0 then  
        local airbase = BLUE_AIRBASE_SET:GetRandomAirbase()
        local grp = spawn_BLUE_AWACS:SpawnAtAirbase(airbase,spawnType, nil, AIRBASE.TerminalType.OpenBig, true)
        
        -- IF SPAWNED
        grp:HandleEvent(EVENTS.Birth)
        function grp:OnEventBirth( EventData )
          local spawnedUnit = EventData.IniUnit
          if spawnedUnit == grp:GetUnit(1) then                       
        
            -- CHECK FOR RESPAWN
            SCHEDULER:New( nil, respawnAwacs, {grp,side}, 1 )  
              
            -- ADD HANDLERS
            local grpUnits = grp:GetUnits()
            for i = 1, #grpUnits do
              local Unit = grp:GetUnit( i )

              -- IF TAKEOFF      
              Unit:HandleEvent(EVENTS.Takeoff)
              function Unit:OnEventTakeoff( EventData )
                sendInfo (Unit:GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat")  .. " AWACS has departed from " .. EventData.PlaceName,side,messageTime)      
              end
                          
              -- IF CHRASHED      
              Unit:HandleEvent(EVENTS.Crash)
              function Unit:OnEventCrash( EventData )
                sendInfo (Unit:GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat")  .. " AWACS has been killed","all",messageTime)      
              end
   
              --IF LANDED
              Unit:HandleEvent(EVENTS.Land)
              function Unit:OnEventLand( EventData )
                if despawnType == "LAND" then Unit:Destroy() end
              end
              
              -- IF ENGINE SHUTDOWN                                   
              Unit:HandleEvent(EVENTS.EngineShutdown)
              function Unit:OnEventEngineShutdown( EventData )
                if not Unit:InAir() then
                  if despawnType == "SHUTDOWN" then Unit:Destroy() end
                end
              end
  
              -- IF STUCK
              local vec2 = Unit:GetVec2()
              SCHEDULER:New( nil, cleanupUnit, {Unit, grp, vec2}, cleanupInterval ) 
                    
            end              
          end
        end      
            
      else
        MESSAGE:New( side .. " HAS NO MORE AIRBASES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
      end
    end
  else
    SCHEDULER:New( nil, spawnAwacs, {side}, 1 )  
  end
end

function respawnAwacs (grp,side)  
  if grp:IsAlive() then
    SCHEDULER:New( nil, respawnAwacs, {grp,side}, 10 )    
  else
    spawnAwacs(side)
  end 
end

-- CLIENT FUNCTIONS
function sendInfo (message,coalition,displayTime)
  if DEBUG then
    MESSAGE:New( message, displayTime, nil ):ToAll()
    beepSound:ToAll()
  else
    if coalition == "all" then
      CLIENTS_SET:ForEachClient(function(CLIENT)
        local clientGrp = CLIENT:GetGroup() 
        local status = messageStatus [CLIENT]
        if status then
          MESSAGE:New( message, displayTime, nil ):ToClient(CLIENT)
          beepSound:ToClient(CLIENT)
        end   
      end) 
    else      
      CLIENTS_SET:ForEachClient(function(CLIENT)
        local clientGrp = CLIENT:GetGroup() 
        local status = messageStatus [CLIENT]
        local side = nil
        if CLIENT:GetCoalition() == 1 then side = "red" end
        if CLIENT:GetCoalition() == 2 then side = "blue" end      
        if status and side == coalition then
          MESSAGE:New( message, displayTime, nil ):ToClient(CLIENT)
          beepSound:ToClient(CLIENT)
        end   
      end)            
    end
  end 
end

function initClient (CLIENT)
  CLIENT:Alive(function (CLIENT)
    MESSAGE:New( CLIENT.ClientName .. " is detected", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    
    targetMarks[CLIENT] = {}
    menuItems[CLIENT] = {}
    sceneryDestroyed[CLIENT] = {}
    sceneryTarget[CLIENT] = {}
    messageStatus[CLIENT] = false
    picturesUpdate[CLIENT] = false  
    inAir[CLIENT] = false
    activeTarget[CLIENT] = 0
    
    -- ADD MISSION HANDLERS
    addHandlersClient (CLIENT)

    -- ADD MENU
    newMenu (CLIENT)
    
    -- MSG
    local clientGrp = CLIENT:GetGroup() 
    SCHEDULER:New( nil, function ()
      SCHEDULER:New( nil, getStageInfo, {CLIENT}, 2 ) 
      
      -- Assign a mission
      SCHEDULER:New( nil, fn_GetTarget,{CLIENT}, 4 ) 
    end, {}, 1 )    
  end)
end

function addHandlersClient (client)

  local side = nil
  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue"  end

  -- non dovrebbe servire più...
  --trigger.action.setUserFlag("Enemy", 22)

  local wingman = client:GetGroup():GetUnit(2)

  -- IF TAKE OFF
  client:HandleEvent(EVENTS.Takeoff)
  function client:OnEventTakeoff( EventData )  
    sendInfo (client:GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat") .. " is departing from " .. EventData.PlaceName ,side,messageTime)
    inAir[client] = true
    newMenu(client)

    local clientGrp = client:GetGroup()
    if string.starts(clientGrp:GetName(), "CAP") then
      SCHEDULER:New( nil, fn_checkAirTARGET, {client,"NEAREST"}, 30 )
    end
    --trigger.action.setUserFlag("Takeoff", true)                
  end
      
  -- IF CRASHED      
  client:HandleEvent(EVENTS.Crash)
  function client:OnEventCrash( EventData )
    if side == "blue" then aircraftBLUE = aircraftBLUE - 1 end  
    if side == "red"  then aircraftRED = aircraftRED - 1 end
    sendInfo (client:GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat") .. " has been killed","all",messageTime)      
  end
  
  --IF LANDED
  client:HandleEvent(EVENTS.Land)
  function client:OnEventLand( EventData )
    sendInfo (client:GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat") .. " has landed at " .. EventData.PlaceName,side,messageTime)
    trigger.action.setUserFlag("Landing", true)
    inAir[client] = false
    newMenu(client)
    
    local clientGrp = client:GetGroup() 
    local Success1 = trigger.misc.getUserFlag("Success1") 
    local Success2 = trigger.misc.getUserFlag("Success2") 

    if Success1 == 1 or Success2 == 1 then
      MESSAGE:New( "Mission completed, good job!", clientTime, nil ):ToClient(client)   
      beepSoundClient:ToGroup(clientGrp)
    end

    if Success1 ~= 1 and Success2 ~= 1 then 
      MESSAGE:New( "The objectives were not achieved, the mission was a failure", clientTime, nil ):ToClient(client)    
      beepSoundClient:ToGroup(clientGrp)
    end
  end
  
  --IF WINGMAN LANDED
  wingman:HandleEvent(EVENTS.Land)
  function wingman:OnEventLand( EventData )
    trigger.action.setUserFlag("Landing2", true)
    MESSAGE:New( "Your wingman has successfully landed", clientTime, nil ):ToClient(client)
    beepSoundClient:ToGroup(clientGrp)    
  end

  --IN IP ZONE
  local IPZone = nil
  local clientGrp  = client:GetGroup()

  if string.find(clientGrp:GetName(), "Incirlik") ~= nil or string.find(clientGrp:GetName(), "CVN71") ~= nil then
    IPZone = ZONE:FindByName("blueZone1")
  end

  if string.find(clientGrp:GetName(), "Arzaq") ~= nil then
    IPZone = ZONE:FindByName("blueZone3")
  end

  local triggerzone = IPZone:Trigger(client)

  function triggerzone:OnAfterEnteredZone(From,Event,To,Group)
    onStationVisibility [client] = true
    -- RESET MENU
    newMenu (client)
  end

  function triggerzone:OnAfterLeftZone(From,Event,To,Group)
    onStationVisibility [client] = false
    callOnStation [client] = false
    -- RESET MENU
    newMenu (client)
  end
end

-- Deprecata
function getProgress (client)
  if initMission then
    local clientGrp = client:GetGroup()
    local RedUnitCount = 0
    local BlueUnitCount = 0
    RED_TARGET_SET:ForEachGroupAlive(function (GROUP) RedUnitCount = RedUnitCount + getAliveUnitsGrp(GROUP) end)  
    BLUE_TARGET_SET:ForEachGroupAlive(function (GROUP) BlueUnitCount = BlueUnitCount + getAliveUnitsGrp(GROUP) end)     
    local progressRED = math.floor(100*(totalBlueUnitCount-BlueUnitCount)/totalBlueUnitCount)
    local progressBLUE = math.floor(100*(totalRedUnitCount-RedUnitCount)/totalRedUnitCount)
    MESSAGE:New(blueFaction .. " battle progress: " .. progressBLUE .. "% - " .. RedUnitCount .. " of " .. totalRedUnitCount .. " targets left, " .. aircraftBLUE .. " aircraft operational", clientTime, nil ):ToClient(client)
    MESSAGE:New(redFaction .. " battle progress: " .. progressRED .. "% - " .. BlueUnitCount .. " of " .. totalBlueUnitCount .. " targets left, " .. aircraftRED .. " aircraft operational", clientTime, nil ):ToClient(client)
    beepSoundClient:ToGroup(clientGrp)
  else
    SCHEDULER:New( nil, getProgress, {client}, 1 )  
  end  
end

function showGroundTargetInfo (client)

  local clientGrp   = client:GetGroup()
  local target = targetStatus [client]

  local targetSize = nil
  local targetType = nil
  local targetAirbase = nil
  local aliveUnits = nil
  local location = nil
  local infoMessage = "*** MISSION: CAS ***\nAttack the following target near "
  local side = nil
  local JTACInfo = ""

  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end
  
  -- RETRIEVE TARGET INFO
  local targetInfo = targetGroups[target]

  if targetInfo ~= nil then
    targetSize = targetInfo["size"]
    targetType = target:GetName()

    MESSAGE:New("Target is " .. targetType, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 

    if string.find(targetType, "ARMOR") ~= nil then
      targetType = "ARMOURED GROUP"
    end

    if string.find(targetType, "ARTILLERY") ~= nil then
      targetType = "ARTILLERY GROUP"
    end

    if string.find(targetType, "AIR DEFENCE") ~= nil then
      targetType = "AIR DEFENCE SITE"
    end

    if string.find(targetType, "BASE") ~= nil then
      targetType = "ENEMY BASE"
    end

    if string.find(targetType, "SAM") ~= nil then
      targetType = "SAM SITE"
    end

    targetAirbase = targetInfo["airbase"]
    
    aliveUnits = getAliveUnitsGrp(target)  
    location = targetAirbase:GetName():gsub("Geo ", "")
  else
    targetType = target:GetTypeName():gsub("0", ""):gsub("1", ""):gsub("2", ""):gsub("3", ""):gsub("4", ""):gsub("5", ""):gsub("6", ""):gsub("7", ""):gsub("8", ""):gsub("9", ""):gsub("_", " ")
    location = ALL_TOWN_SET:FindNearestObjectFromPointVec2(target:GetPointVec2()):GetName():gsub("Geo ", "")
  end

  local clientCoord = client:GetCoordinate()
  local targetCoord = target:GetCoordinate()
  local targetHeight = math.floor(target:GetCoordinate():GetLandHeight())
  local targetHeightFt = math.floor(3.2808399 * target:GetCoordinate():GetLandHeight())
  local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(targetCoord))
  local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(targetCoord)/1000)

  --local targetVector = clientCoord:GetDirectionVec3(targetCoord)
  --local targetBearing = clientCoord:GetAngleRadians (targetVector)  

  local targetVector = clientCoord:GetDirectionVec3(targetCoord)
  local targetBearing = math.floor(clientCoord:GetAngleDegrees(targetVector)) .. "°" 

  _SETTINGS:SetImperial()
  --local playerBearing = clientCoord:GetBRText(targetBearing, playerDistance)   
  local bearingMsg = nil
  local elevationMsg = nil 
  
  if side == "red" then
    bearingMsg = "bearing ".. targetBearing .. " for " .. playerDistanceMeters .. " km"
    elevationMsg = "Elevation "..targetHeight.." m"  
  end
  if side == "blue" then
    bearingMsg = "bearing ".. targetBearing ..  " for " .. playerDistance .. " nm"
    elevationMsg = "Elevation " .. targetHeightFt .. " ft"  
  end
  
  --_SETTINGS:SetLL_Accuracy(4)
  --local CoordStringLLDMS = targetCoord:ToStringLLDMS()
  _SETTINGS:SetLL_Accuracy(4)
  local CoordStringLLDDM = targetCoord:ToStringLLDDM()
  _SETTINGS:SetLL_Accuracy(3)
  local CoordStringMGRSS = targetCoord:ToStringMGRS()

  local intelligence = "Additional Details\n- Intelligence reports Manpads in the area, pay attention below 15000 feet\n- Russian Federation has established a no-fly zone over the Latakia province of western Syria, any unauthorized object will be intercepted and attacked, avoid that area"
  
  if string.find(targetType, "BASE") == nil and JTACNames [client] ~= nil and JTACFreqs [client] ~= nil then
    JTACInfo = "\nJTAC " .. JTACNames [client] .. " is available at " .. JTACFreqs [client] .. " MHz AM for instructions"
  end

  if targetInfo ~= nil then
    local unitMessage = " unit in total\n"
    if aliveUnits > 1 then unitMessage = " units in total\nDestroy or hit as many units as possible\n\n" end
    infoMessage = infoMessage .. location .. " via Waypoint 1 (IP)\n\n" .. targetType .. "\nTarget consist in " .. aliveUnits .. unitMessage .. "Target is at " .. bearingMsg .. "\n" .. elevationMsg .. JTACInfo .. "\nMarks are available in F10 map\n\nCoordinates\n" .. CoordStringLLDDM .. "\n" .. CoordStringMGRSS .. "\n\n" .. intelligence .. "\n "
  else
    infoMessage = infoMessage .. location .. "\n\n" .. targetType .. "\nTarget is at " .. bearingMsg .. "\n" .. elevationMsg .. "\nMarks are available in F10 map\n\nCoordinates\n" .. CoordStringLLDMS .. "\n" .. CoordStringLLDDM .. "\n" .. CoordStringMGRSS .. "\n\n" .. intelligence .. "\n "
  end

  --addMarks(client)
  SCHEDULER:New( nil, addMarks, {client}, 10 )
  MESSAGE:New( infoMessage, targetTime, nil ):ToClient(client)   
  beepSoundClient:ToGroup(clientGrp)
end

function showConvoyTargetInfo (client)
  local clientGrp = client:GetGroup()
  local targetSpawn  = targetStatus [client]
  local originalTargetUnitCount = clientTargetCount [client]
  local target = getAliveGroupSpawn(targetSpawn)
  local aliveUnits = getAliveUnitsSpawn(targetSpawn)
  local infoMessage = "*** MISSION: AI ***\nAn enemy supply convoy was detected, intercept it via Waypoint 1 (IP)\n\n"
  local side = nil

  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end

  local clientCoord = client:GetCoordinate()
  local targetCoord = target:GetCoordinate()
  local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(targetCoord))
  local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(targetCoord)/1000)

  local targetVector = clientCoord:GetDirectionVec3(targetCoord)
  local targetBearing = math.floor(clientCoord:GetAngleDegrees(targetVector)) .. "°" 

  _SETTINGS:SetImperial()
  --local playerBearing = clientCoord:GetBRText(targetBearing, playerDistance)   
  local bearingMsg = nil
  local elevationMsg = nil 
  
  if side == "red" then
    bearingMsg = "bearing ".. targetBearing .. " for " .. playerDistanceMeters .. " km"
  end
  if side == "blue" then
    bearingMsg = "bearing ".. targetBearing ..  " for " .. playerDistance .. " nm"
  end
  
  --_SETTINGS:SetLL_Accuracy(4)
  --local CoordStringLLDMS = targetCoord:ToStringLLDMS()
  _SETTINGS:SetLL_Accuracy(4)
  local CoordStringLLDDM = targetCoord:ToStringLLDDM()
  _SETTINGS:SetLL_Accuracy(3)
  local CoordStringMGRSS = targetCoord:ToStringMGRS()

  local intelligence = "Additional Details\n- Intelligence reports Manpads in the area, pay attention below 15000 feet\n- Russian Federation has established a no-fly zone over the Latakia province of western Syria, any unauthorized object will be intercepted and attacked, avoid that area"
  
  local unitMessage = " unit in total\n"
  if aliveUnits > 1 then unitMessage = " units in total\nDestroy or hit as many units as possible\n\n" end
  infoMessage = infoMessage .. "Target probably consist in " .. aliveUnits .. unitMessage .. "Target is currently at " .. bearingMsg .. "\nMarks are available in F10 map\nCheck \"Mission Briefing\" under \"Target menu\" to get position updates\n\nCurrent coordinates\n" .. CoordStringLLDDM .. "\n" .. CoordStringMGRSS .. "\n\n" .. intelligence .. "\n "
 
  addMarksMovingConvoy(client)
  MESSAGE:New( infoMessage, targetTime, nil ):ToClient(client)   
  beepSoundClient:ToGroup(clientGrp)  
end

function showRunwayTargetInfo (client)

  local clientGrp   = client:GetGroup()
  local target = targetStatus [client]

  --local targetSize = nil
  local targetAirbase = nil
  local infoMessage = "*** MISSION: OCA ***\nDisable the following runway located near "
  local side = nil

  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end
  
  local clientCoord = client:GetCoordinate()
  local targetCoord = target:GetCoordinate()
  local targetHeight = math.floor(target:GetCoordinate():GetLandHeight())
  local targetHeightFt = math.floor(3.2808399 * target:GetCoordinate():GetLandHeight())
  local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(targetCoord))
  local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(targetCoord)/1000)

  local targetVector = clientCoord:GetDirectionVec3(targetCoord)
  local targetBearing = math.floor(clientCoord:GetAngleDegrees(targetVector)) .. "°" 

  local targetType = "RUNWAY"
  if target:GetProperty("NAME") ~= nil then
    targetType = target:GetProperty("NAME")
  end

  local location = ALL_TOWN_SET:FindNearestObjectFromPointVec2(target:GetPointVec2()):GetName():gsub("Geo ", "")

  _SETTINGS:SetImperial()
  local bearingMsg = nil
  local elevationMsg = nil 
  
  if side == "red" then
    bearingMsg = "bearing ".. targetBearing .. " for " .. playerDistanceMeters .. " km"
    elevationMsg = "Elevation "..targetHeight.." m"  
  end
  if side == "blue" then
    bearingMsg = "bearing ".. targetBearing ..  " for " .. playerDistance .. " nm"
    elevationMsg = "Elevation " .. targetHeightFt .. " ft"  
  end
  
  --_SETTINGS:SetLL_Accuracy(4)
  --local CoordStringLLDMS = targetCoord:ToStringLLDMS()
  _SETTINGS:SetLL_Accuracy(4)
  local CoordStringLLDDM = targetCoord:ToStringLLDDM()
  _SETTINGS:SetLL_Accuracy(3)
  local CoordStringMGRSS = targetCoord:ToStringMGRS()

  local intelligence = "Additional Details\n- Intelligence reports Manpads in the area, pay attention below 15000 feet\n- Russian Federation has established a no-fly zone over the Latakia province of western Syria, any unauthorized object will be intercepted and attacked, avoid that area"
  
  infoMessage = infoMessage .. location .. " via Waypoint 1 (IP)\n\n" .. targetType .. "\nTarget is at " .. bearingMsg .. "\n" .. elevationMsg .. "\nCheck marks in F10 map to locate the correct runway\n\nCoordinates\n" .. CoordStringLLDDM .. "\n" .. CoordStringMGRSS .. "\n\n" .. intelligence .. "\n "

  addMarksRunway(client)
  MESSAGE:New( infoMessage, targetTime, nil ):ToClient(client)   
  beepSoundClient:ToGroup(clientGrp)
end

function showStructureTargetInfo (client)

  local clientGrp   = client:GetGroup()
  local target = targetStatus [client]

  --local targetSize = nil
  local targetAirbase = nil
  local infoMessage = "*** MISSION: PRECISION STRIKE ***\nAttack the following target near "
  local side = nil

  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end
  
  local clientCoord = client:GetCoordinate()
  local targetCoord = target:GetCoordinate()
  local targetHeight = math.floor(target:GetCoordinate():GetLandHeight())
  local targetHeightFt = math.floor(3.2808399 * target:GetCoordinate():GetLandHeight())
  local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(targetCoord))
  local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(targetCoord)/1000)

  local targetVector = clientCoord:GetDirectionVec3(targetCoord)
  local targetBearing = math.floor(clientCoord:GetAngleDegrees(targetVector)) .. "°" 

  local targetType = "STRUCTURES"
  if target:GetProperty("NAME") ~= nil then
    targetType = target:GetProperty("NAME")
  end
  
  local aliveUnits = getAliveStructuresZone(target)  
  local location = ALL_TOWN_SET:FindNearestObjectFromPointVec2(target:GetPointVec2()):GetName():gsub("Geo ", "")

  _SETTINGS:SetImperial()
  local bearingMsg = nil
  local elevationMsg = nil 
  
  if side == "red" then
    bearingMsg = "bearing ".. targetBearing .. " for " .. playerDistanceMeters .. " km"
    elevationMsg = "Elevation "..targetHeight.." m"  
  end
  if side == "blue" then
    bearingMsg = "bearing ".. targetBearing ..  " for " .. playerDistance .. " nm"
    elevationMsg = "Elevation " .. targetHeightFt .. " ft"  
  end
  
  --_SETTINGS:SetLL_Accuracy(4)
  --local CoordStringLLDMS = targetCoord:ToStringLLDMS()
  _SETTINGS:SetLL_Accuracy(4)
  local CoordStringLLDDM = targetCoord:ToStringLLDDM()
  _SETTINGS:SetLL_Accuracy(3)
  local CoordStringMGRSS = targetCoord:ToStringMGRS()

  local intelligence = "Additional Details\n- Intelligence reports Manpads in the area, pay attention below 15000 feet\n- Russian Federation has established a no-fly zone over the Latakia province of western Syria, any unauthorized object will be intercepted and attacked, avoid that area"

  local unitMessage = " structure in total\n"
  if aliveUnits > 1 then unitMessage = " structures in total\nDestroy or damage as many structures as possible\n\n" end
  infoMessage = infoMessage .. location .. " via Waypoint 1 (IP)\n\n" .. targetType .. "\nTarget consist in " .. aliveUnits .. unitMessage .. "Target is at " .. bearingMsg .. "\n" .. elevationMsg .. "\nMarks are available in F10 map\n\nCoordinates\n" .. CoordStringLLDDM .. "\n" .. CoordStringMGRSS .. "\n\n" .. intelligence .. "\n "

  addMarksStructure(client)
  MESSAGE:New( infoMessage, targetTime, nil ):ToClient(client)   
  beepSoundClient:ToGroup(clientGrp)
end

function showStaticTargetInfo (client)

  local clientGrp   = client:GetGroup()
  local target = targetStatus [client]

  --local targetSize = nil
  local targetAirbase = nil
  local infoMessage = "*** MISSION: OCA ***\nAttack the following target near "
  local side = nil

  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end
  
  local clientCoord = client:GetCoordinate()
  local targetCoord = target:GetCoordinate()
  local targetHeight = math.floor(target:GetCoordinate():GetLandHeight())
  local targetHeightFt = math.floor(3.2808399 * target:GetCoordinate():GetLandHeight())
  local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(targetCoord))
  local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(targetCoord)/1000)

  local targetVector = clientCoord:GetDirectionVec3(targetCoord)
  local targetBearing = math.floor(clientCoord:GetAngleDegrees(targetVector)) .. "°" 

  local targetType = "PARKED AIRCRAFTS"
  
  local aliveUnits = getAliveStaticPrefix(target:GetName())  
  local location = target:GetName()

  _SETTINGS:SetImperial()
  local bearingMsg = nil
  local elevationMsg = nil 
  
  if side == "red" then
    bearingMsg = "bearing ".. targetBearing .. " for " .. playerDistanceMeters .. " km"
    elevationMsg = "Elevation "..targetHeight.." m"  
  end
  if side == "blue" then
    bearingMsg = "bearing ".. targetBearing ..  " for " .. playerDistance .. " nm"
    elevationMsg = "Elevation " .. targetHeightFt .. " ft"  
  end
  
  --_SETTINGS:SetLL_Accuracy(4)
  --local CoordStringLLDMS = targetCoord:ToStringLLDMS()
  _SETTINGS:SetLL_Accuracy(4)
  local CoordStringLLDDM = targetCoord:ToStringLLDDM()
  _SETTINGS:SetLL_Accuracy(3)
  local CoordStringMGRSS = targetCoord:ToStringMGRS()

  local intelligence = "Additional Details\n- Intelligence reports Manpads in the area, pay attention below 15000 feet\n- Russian Federation has established a no-fly zone over the Latakia province of western Syria, any unauthorized object will be intercepted and attacked, avoid that area"

  local unitMessage = " units in total\n"
  if aliveUnits > 1 then unitMessage = " units in total\nDestroy or damage as many units as possible\n\n" end
  infoMessage = infoMessage .. location .. " airbase via Waypoint 1 (IP)\n\n" .. targetType .. "\nTarget consist in " .. aliveUnits .. unitMessage .. "Target is at " .. bearingMsg .. "\n" .. elevationMsg .. "\nMarks are available in F10 map\n\nCoordinates\n" .. CoordStringLLDDM .. "\n" .. CoordStringMGRSS .. "\n\n" .. intelligence .. "\n "

  addMarksStatic(client)
  MESSAGE:New( infoMessage, targetTime, nil ):ToClient(client)   
  beepSoundClient:ToGroup(clientGrp)
end

function addMarks(client)
  deleteMarks(client)
  local clientGrp   = client:GetGroup()
  local target      = targetStatus [client]
  local targetInfo = targetGroups[target]

  if targetInfo ~= nil then
    local targetUnits = #target:GetUnits()

    for i = 1, targetUnits do 
      local Unit = target:GetUnit( i ) 
      local UnitCoord = Unit:GetCoordinate()
      local MarkID = UnitCoord:MarkToGroup("TARGET: " .. Unit:GetTypeName(), clientGrp, true)

      table.insert(targetMarks[client],MarkID)
    end
  else
      local UnitCoord = target:GetCoordinate()
      local MarkID = UnitCoord:MarkToGroup("TARGET: " .. target:GetTypeName(), clientGrp, true)

      table.insert(targetMarks[client],MarkID)
  end
end

function addMarksStructure(client)
  deleteMarks(client)
  local clientGrp   = client:GetGroup()
  local target      = targetStatus [client]

  local aliveStructures = SET_SCENERY:NewFromZone(target):FilterOnce()

  aliveStructures:ForEachScenery(function(scenery)
    local sceneryCoord = scenery:GetCoordinate()
    local MarkID = sceneryCoord:MarkToGroup("TARGET: " .. scenery:GetTypeName():gsub("0", ""):gsub("1", ""):gsub("2", ""):gsub("3", ""):gsub("4", ""):gsub("5", ""):gsub("6", ""):gsub("7", ""):gsub("8", ""):gsub("9", ""):gsub("_", " "), clientGrp, true)

    table.insert(targetMarks[client],MarkID)
  end)
end

function addMarksStatic(client)
  deleteMarks(client)
  local clientGrp   = client:GetGroup()
  local target      = targetStatus [client]

  local aliveUnits = SET_STATIC:New():FilterPrefixes(target:GetName()):FilterOnce()

  aliveUnits:ForEachStatic(function(static)
    local sceneryCoord = static:GetCoordinate()
    local MarkID = sceneryCoord:MarkToGroup("TARGET: Parked aircraft", clientGrp, true)

    table.insert(targetMarks[client],MarkID)
  end)
end

function addMarksMovingConvoy(client)
  deleteMarks(client)
  local clientGrp   = client:GetGroup()
  local targetSpawn = targetStatus [client]
  local target = getAliveGroupSpawn(targetSpawn)

  local UnitCoord = target:GetCoordinate()
  local MarkID = UnitCoord:MarkToGroup("TARGET: Supply convoy", clientGrp, true)

  table.insert(targetMarks[client],MarkID)
end

function addMarksRunway(client)
  deleteMarks(client)
  local clientGrp   = client:GetGroup()
  local target = targetStatus [client]

  local UnitCoord = target:GetCoordinate()
  local MarkID = UnitCoord:MarkToGroup("TARGET: Runway", clientGrp, true)

  table.insert(targetMarks[client],MarkID)
end

function deleteMarks(client)
  -- Delete previous marks
  for k,v in pairs(targetMarks[client]) do
    UTILS.RemoveMark(targetMarks[client][k])
  end

  targetMarks[client] = {}
end

function showAirTargetInfo (client)

  local clientGrp = client:GetGroup()
  local target = targetStatus [client]
  local targetBearing = ""
  local altitudeMsg = nil
  local distanceMsg = nil
  local side = nil

  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end

   -- RETRIEVE TARGET INFO
  local targetInfo = airGroups[target]

  --local targetAirbase = targetInfo["airbase"]
  --local targetTarget = targetInfo["target"]
  local targetType = targetInfo["type"] 

  local aliveUnits = getAliveUnitsGrp(target)    

  local clientCoord = client:GetCoordinate()
  local targetCoord = target:GetCoordinate()
  local targetHeight = math.floor(3.2808399 * target:GetUnit(1):GetAltitude())
  local targetHeightMeters = math.floor(target:GetUnit(1):GetAltitude())
  local playerDistance = clientCoord:Get2DDistance(targetCoord)

  _SETTINGS:SetImperial()

  if clientCoord:Get2DDistance(targetCoord)>metersRangeTogheder then
    local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(targetCoord))
    local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(targetCoord)/1000)
    if side == "red" then distanceMsg = "for " .. playerDistanceMeters .. " km" end
    if side == "blue" then distanceMsg = "for " .. playerDistance .." nm" end

    local targetVector = clientCoord:GetDirectionVec3(targetCoord)
    targetBearing = math.floor(clientCoord:GetAngleDegrees(targetVector)) .. "° " 
  else
    distanceMsg = "MERGED"
  end

  _SETTINGS:SetImperial()
  if side == "red" then
    altitudeMsg = targetHeightMeters .. " m"  
  end
  if side == "blue" then
    altitudeMsg = targetHeight .." ft"  
  end

  local infoMessage = "*** TARGET ASSIGNED ***\nProceed to intercept the following group\n\n" .. aliveUnits .. " x " .. targetType .. " - " .. targetBearing .. distanceMsg .. " at " .. altitudeMsg .. "\n\nEnable continuous picture updates to receive directions from GCI"

  MESSAGE:New( infoMessage, targetTime, nil ):ToClient(client)   
  beepSoundClient:ToGroup(clientGrp)
end

-- DA RIVEDERE...--------------------------------------
function GCIMessage (client)
  if picturesUpdate [client] then
    SCHEDULER:New( nil, GCIMessage, {client}, 60 )
    picturesUpdate [client] = true
    local clientGrp   = client:GetGroup()

    local target = targetStatus [client]
    local targetName = nil
    if target ~= nil and string.starts(clientGrp:GetName(), "CAP") then targetName = target:GetName() end

    local side = nil
    local opfor = nil
    if client:GetCoalition() == 1 then side = "red" opfor = "blue" end
    if client:GetCoalition() == 2 then side = "blue" opfor = "red" end

    if getAirbornGroups(opfor) > 0 then  
      -- GET TARGET 
      local targetset = {}
      local GCIString = "*** CURRENT PICTURE UPDATE ***\nReference self\n\n"
      for grp,grpInfo in pairs(airGroups) do   
        local grpSide = grpInfo["side"]
        if side ~= grpSide then
          table.insert(targetset, grp)     
        end
      end

      for i = 1, #targetset do
        local units = targetset[i]:GetUnits()

        for u = 1, #units do
          local aliveUnits = 0

          if u == 1 then
            aliveUnits = countHowManyWithLeader(targetset[i]:GetUnit(u))
          else
            if not unitWithLeader(targetset[i]:GetUnit(u)) then
              aliveUnits = 1
            end
          end

          if aliveUnits > 0 then
            local targetBearing = ""
            local altitudeMsg = nil
            local distanceMsg = nil
            local bullet = "- "
            local suffix = ""
            local targetType = targetset[i]:GetUnit(u):GetTypeName():gsub("_2", " Warthog"):gsub("_50", " Viper"):gsub("_hornet", " Hornet"):gsub("8BNA", "-8B Harrier II"):gsub("-14B", "-14B Tomcat")     
            local clientCoord = client:GetCoordinate()
            local targetCoord = targetset[i]:GetUnit(u):GetCoordinate()
            local targetHeight = math.floor(3.2808399 * targetset[i]:GetUnit(u):GetAltitude())
            local targetHeightMeters = math.floor(targetset[i]:GetUnit(u):GetAltitude())

            if clientCoord:Get2DDistance(targetCoord)>2000 then
              local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(targetCoord))
              local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(targetCoord)/1000)
              if side == "red" then distanceMsg = "for " .. playerDistanceMeters .. " km" end
              if side == "blue" then distanceMsg = "for " .. playerDistance .." nm" end

              local targetVector = clientCoord:GetDirectionVec3(targetCoord)
              targetBearing = math.floor(clientCoord:GetAngleDegrees(targetVector)) .. "° " 
            else
              distanceMsg = "MERGED"
            end

            if targetset[i]:GetName() == targetName then
              bullet = "> "
              suffix = " <-- YOUR TARGET"
            end

            _SETTINGS:SetImperial()
            if side == "red" then
              altitudeMsg = targetHeightMeters .. " m"  
            end
            if side == "blue" then
              altitudeMsg = targetHeight .." ft"  
            end

            GCIString = GCIString .. bullet .. aliveUnits .. " x " .. targetType .. " - " .. targetBearing .. distanceMsg .. " at " .. altitudeMsg .. suffix .. "\n\n"
          end
        end
      end 

      MESSAGE:New(GCIString .. " ", clientTime, nil ):ToClient(client)
      beepSoundClient:ToGroup(clientGrp)  

    else
      -- MSG    
      MESSAGE:New( "*** CURRENT PICTURE UPDATE ***\nReference self\n\nCLEAN", clientTime, nil ):ToClient(client)
    end
  end
end

function showJDAMcoord (client)
  _SETTINGS:SetLL_Accuracy(4)
  local clientGrp   = client:GetGroup()
  local target      = targetStatus [client]
  local coordString = "*** COMPLETE TARGET LIST ***\n\n"
  -- local targetType = nil 
  
  local side = nil
  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end 

  local targetInfo = targetGroups[target]

  if targetInfo ~= nil then
    local targetUnits = #target:GetUnits()

    for i = 1, targetUnits do 
      local Unit = target:GetUnit( i ) 
      local UnitCoord = Unit:GetCoordinate()
      --local MarkID = UnitCoord:MarkToGroup("TARGET: " .. Unit:GetTypeName(), clientGrp, true)
      local UnitHeight = math.floor(UnitCoord:GetLandHeight() * 100)/100   
      local CoordStringLLDDM = UnitCoord:ToStringLLDDM()
      --local CoordStringLLDMS = UnitCoord:ToStringLLDMS()
      local CoordStringMGRSS = UnitCoord:ToStringMGRS()

      --table.insert(targetMarks[client],MarkID)
      --env.info("Mark: ".. MarkID)

      local height = nil

      if side == "red" then
        height = math.floor(UnitHeight) .. " m"  
      end
      if side == "blue" then
        height = math.floor(UnitHeight * 3.281) .. " ft"  
      end

      coordString = coordString .. "TARGET " .. i .. " - " .. Unit:GetTypeName() .. "\n" .. CoordStringLLDDM .. "\n" .. CoordStringMGRSS .. "\n" .. height .. "\n\n"
    end
  else
      -- Si tratta di strutture
      local structures = SET_SCENERY:NewFromZone(target):FilterOnce()

      structures:ForEachScenery(function(scenery)
        local UnitCoord = scenery:GetCoordinate()
        local UnitHeight = math.floor(UnitCoord:GetLandHeight() * 100)/100   
        local CoordStringLLDDM = UnitCoord:ToStringLLDDM()
        local CoordStringLLDMS = UnitCoord:ToStringLLDMS()
        local CoordStringMGRSS = UnitCoord:ToStringMGRS()
        local height = nil
  
        if side == "red" then
          height = math.floor(UnitHeight) .. " m"  
        end
        if side == "blue" then
          height = math.floor(UnitHeight * 3.281) .. " ft"  
        end

        coordString = coordString .. "TARGET - " .. scenery:GetTypeName():gsub("0", ""):gsub("1", ""):gsub("2", ""):gsub("3", ""):gsub("4", ""):gsub("5", ""):gsub("6", ""):gsub("7", ""):gsub("8", ""):gsub("9", ""):gsub("_", " ") .. "\n" .. CoordStringLLDDM .. "\n" .. CoordStringLLDMS .. "\n" .. CoordStringMGRSS .. "\n" .. height .. "\n\n"
      end)
  end

  MESSAGE:New( coordString .. " ", targetTime, nil ):ToClient(client)
  beepSoundClient:ToGroup(clientGrp)  
end

function showCoalitionFlights (client)
  local clientGrp   = client:GetGroup()
  
  local side = nil
  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end 

  if getAirbornGroups(side) > 0 then
    local messageString = "*** " .. getAirbornGroups(side) .. " COALITION FLIGHT"
    if getAirbornGroups(side) > 1 then messageString = messageString .. "S" end
    messageString = messageString .. " ***\n \n"
    for grp,grpInfo in pairs(airGroups) do 
      local grpSide = grpInfo["side"]
      local grpTask = grpInfo["task"]
      local grpType = grpInfo["type"]
      if side ==  grpSide then        
        local zone = ALL_TOWN_SET:FindNearestObjectFromPointVec2(grp:GetPointVec2())  
        if grpTask == "SAM" or grpTask == "AIR DEFENCE" then messageString = messageString .. grpType .. " SEAD flight near " .. zone:GetName():gsub("Geo ", "") .. "\n" end
        if grpTask == "ARMOR" or grpTask == "ARTILLERY" then messageString = messageString .. grpType .. " CAS flight near " .. zone:GetName():gsub("Geo ", "") .. "\n" end
        if grpTask == "CONVOY" then messageString = messageString .. grpType .. " AI flight near " .. zone:GetName():gsub("Geo ", "") .. "\n" end
        if grpTask == "AIRBASE" or grpTask == "RUNWAY" then messageString = messageString .. grpType .. " OCA flight near " .. zone:GetName():gsub("Geo ", "") .. "\n" end 
        if grpTask == "STRIKE" or grpTask == "BASE" then messageString = messageString .. grpType .. " STRIKE flight near " .. zone:GetName():gsub("Geo ", "") .. "\n" end            
        if grpTask == "CAP" then messageString = messageString .. grpType .. " CAP flight near " .. zone:GetName():gsub("Geo ", "") .. "\n" end      
      end
    end  
    MESSAGE:New( messageString .. " ", clientTime, nil ):ToClient(client) 
  else
    MESSAGE:New( "Currently there are no active coalition flights", clientTime, nil ):ToClient(client) 
  end
  beepSoundClient:ToGroup(clientGrp) 
end

function showCoalitionTargets (client)
  local clientGrp = client:GetGroup()
  
  local side = nil
  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end 

  local escortGroups = {}
  for grp,grpInfo in pairs(airGroups) do
    local grpSide = grpInfo["side"] 
    local grpTarget = grpInfo["target"]   
    if side ==  grpSide and grpTarget ~= nil then
      table.insert(escortGroups, grp)    
    end
  end
  
  if #escortGroups > 0 then
    local messageString = "*** " .. #escortGroups .. " COALITION TARGET"
    if #escortGroups > 1 then messageString = messageString .. "S" end
    messageString = messageString .. " ***\n \n"    
    for i = 1, #escortGroups do
      local escortGrp = escortGroups[i]
      local grpInfo = airGroups[escortGrp]
      local grpSide = grpInfo["side"]
      local grpTask = grpInfo["task"]
      local grpTarget = grpInfo["target"] 
      local grpType = grpInfo["type"]
 
      -- ESCORT GROUP     
      if grpTask == "SAM" or grpTask == "AIR DEFENCE" then messageString = messageString .. grpType .. " SEAD flight " end
      if grpTask == "ARMOR" or grpTask == "ARTILLERY" then messageString = messageString .. grpType .. " CAS flight " end    
      if grpTask == "CONVOY" then messageString = messageString .. grpType .. " AI flight " end
      if grpTask == "AIRBASE" or grpTask == "RUNWAY" then messageString = messageString .. grpType .. " OCA flight " end
      if grpTask == "STRIKE" or grpTask == "BASE" then messageString = messageString .. grpType .. " STRIKE flight " end      
      if grpTask == "CAP" then messageString = messageString .. grpType .. " CAP flight " end 

      -- ESCORT POSITION
      local clientCoord = client:GetCoordinate()
      local escortCoord = escortGrp:GetCoordinate()
      local escortHeight = math.floor(3.2808399 * escortGrp:GetUnit(1):GetAltitude())
      local escortHeightMeters = math.floor(escortGrp:GetUnit(1):GetAltitude())
      local playerDistance = math.floor(0.000539957 * clientCoord:Get2DDistance(escortCoord))
      local playerDistanceMeters = math.floor(clientCoord:Get2DDistance(escortCoord)/1000)    
      local escortVector = clientCoord:GetDirectionVec3(escortCoord)
      --local escortBearing = clientCoord:GetAngleRadians (escortVector)  
      local playerBearing = "bearing " .. math.floor(clientCoord:GetAngleDegrees(escortVector)) .. "° "   

      local distanceMessage = nil
      local altitudeMsg = nil       

      if side == "red" then 
        distanceMessage = "for " .. playerDistanceMeters .. " km "
        altitudeMsg = "at ".. escortHeightMeters .." m"        
      end
      if side == "blue" then 
        distanceMessage = "for " .. playerDistance .. " nm "
        altitudeMsg = "at ".. escortHeight .." ft"        
      end

      messageString = messageString .. playerBearing .. distanceMessage .. altitudeMsg .. "\n" 

      local targetCoord = grpTarget:GetCoordinate()
      if targetCoord ~= nil then 
        -- ESCORT TARGET
        local targetHeight = math.floor(grpTarget:GetCoordinate():GetLandHeight())
        local targetHeightFt = math.floor(3.2808399 * grpTarget:GetCoordinate():GetLandHeight())
        local elevationMsg = nil
        
        if side == "red" then 
          elevationMsg = "elevation "..targetHeight.." m"
        end
        if side == "blue" then 
          elevationMsg = "elevation "..targetHeightFt.." ft"
        end
        
        _SETTINGS:SetLL_Accuracy(4)
        local CoordStringLLDDM = targetCoord:ToStringLLDDM()  
        messageString = messageString .. "Target: " .. CoordStringLLDDM .. ", " .. elevationMsg .. "\n \n"    
        
      else
        messageString = messageString .. "Target: Destroyed" .. "\n \n"        
      end
   
    end    
    MESSAGE:New( messageString .. " ", targetTime, nil ):ToClient(client)
  else
    MESSAGE:New( "Currently there are no active coalition flights", clientTime, nil ):ToClient(client)  
  end
  beepSoundClient:ToGroup(clientGrp)
end

function changeTarget (client)
  local clientGrp = client:GetGroup()
  clientTargetCount[client] = 0
  clientTargetHits  [client] = nil
  local target2Free = targetStatus [client]
  local task2Free = missionTask[client]
  missionTask[client] = ""
  targetStatus[client] = nil

  deleteMarks(client)
  
  -- RESET MENU
  newMenu (client)
  
   -- MSG    
   MESSAGE:New( "ASOC: Roger, looking for a new tasking, standby...", clientTime, nil ):ToClient(client)
  beepSoundClient:ToGroup(clientGrp) 

  fn_GetTarget (client)

  -- DISABLE TARGET
  freeTarget (task2Free,target2Free)
end

function winchester (client)
  local clientGrp = client:GetGroup()
  clientTargetCount[client] = 0
  clientTargetHits  [client] = nil
  local target2Free = targetStatus [client]
  local task2Free = missionTask[client]
  missionTask[client] = ""
  targetStatus[client] = nil
  isWinchester[client] = true

  deleteMarks(client)
  
  -- RESET MENU
  newMenu (client)
  
   -- MSG    
  MESSAGE:New( "ASOC: Roger, you may RTB", clientTime, nil ):ToClient(client)
  beepSoundClient:ToGroup(clientGrp) 

  -- DISABLE TARGET
  freeTarget (task2Free,target2Free)
end

function bingo (client)
  local clientGrp = client:GetGroup()
  clientTargetCount[client] = 0
  clientTargetHits  [client] = nil
  local target2Free = targetStatus [client]
  local task2Free = missionTask[client]
  missionTask[client] = ""
  targetStatus[client] = nil

  deleteMarks(client)
  
  -- RESET MENU
  newMenu (client)
  
   -- MSG    
  MESSAGE:New( "ASOC: Roger, contact the tanker for refuelling or RTB", clientTime, nil ):ToClient(client)
  beepSoundClient:ToGroup(clientGrp) 

  -- DISABLE TARGET
  freeTarget (task2Free,target2Free)
end

function taskCompleted (client)
  local clientGrp = client:GetGroup()
  clientTargetCount[client] = 0
  clientTargetHits  [client] = nil
  local target2Free = targetStatus [client]
  local task2Free = missionTask[client]
  missionTask[client] = ""
  targetStatus[client] = nil
  ASOCTaskCompleted[client] = true
  activeTarget[client] = activeTarget[client] + 1

  deleteMarks(client)
  
  -- RESET MENU
  newMenu (client)
  
   -- MSG    
  MESSAGE:New( "ASOC: Roger, let me know if you're available for another task", clientTime, nil ):ToClient(client)
  beepSoundClient:ToGroup(clientGrp) 

  -- DISABLE TARGET
  freeTarget (task2Free,target2Free)
end

function disablePictureUpdates(client) 
  local clientGrp = client:GetGroup()  
  -- DISABLE MESSAGES
  picturesUpdate [client] = false

  -- RESET MENU
  newMenu (client)

  -- MSG
  MESSAGE:New( "Continuous picture updates have been disabled", clientTime, nil ):ToClient(client)
  beepSoundClient:ToGroup(clientGrp)   
end

function enablePictureUpdates(client) 
  local clientGrp = client:GetGroup()  
  -- DISABLE MESSAGES
  picturesUpdate [client] = true

  -- RESET MENU
  newMenu (client)

  -- MSG
  GCIMessage (client)
end

function fn_disableMessages(client) 
  local clientGrp = client:GetGroup()  
  -- DISABLE MESSAGES
  messageStatus [client] = false

  -- RESET MENU
  newMenu (client)

  -- MSG
  MESSAGE:New( "Additional messages have been disabled", clientTime, nil ):ToClient(client)
  beepSoundClient:ToGroup(clientGrp)   
end

function fn_enableMessages(client) 
  local clientGrp = client:GetGroup() 
  -- ENABLE MESSAGES
  messageStatus [client] = true

  -- RESET MENU
  newMenu (client)
  
  -- MSG  
  MESSAGE:New( "Additional messages have been enabled", clientTime, nil ):ToClient(client) 
  beepSoundClient:ToGroup(clientGrp)
end

function onStation(client) 
  local clientGrp = client:GetGroup() 
  -- ENABLE MESSAGES
  callOnStation[client] = true
  waitingTasking[client] = true

  -- RESET MENU
  newMenu (client)
  
  -- MSG  
  MESSAGE:New("ASOC: Roger, establish an orbit and standby for tasking...", clientTime, nil ):ToClient(client) 
  beepSoundClient:ToGroup(clientGrp)

  -- metti qui poi il trigger a tempo per generare la missione
  if missionTask[client] == "FORCE" or missionTask[client] == "BASE" or missionTask[client] == "ARMOR" or missionTask[client] == "ARTILLERY" then
    SCHEDULER:New( nil, fn_GroundTARGET, {client, missionTask[client], "NEAREST"}, math.random(minWaitTime,maxWaitTime) )
  end

  if missionTask[client] == "CONVOY" then
    SCHEDULER:New( nil, fn_ConvoyTARGET, {client}, math.random(minWaitTime,maxWaitTime) )
  end

end

function checkTarget (client)
  if targetStatus [client] ~= nil and (missionTask[client] == "SAM" or missionTask[client] == "ARMOR" or missionTask[client] == "AIR DEFENCE" or missionTask[client] == "ARTILLERY" or missionTask[client] == "BASE" or missionTask[client] == "CAP") then
    local clientGrp = client:GetGroup()
    local target = targetStatus [client]
    local aliveUnits = getAliveUnitsGrp(target)
    local outcome = false 
    local success = false

    if activeTarget[client] ~= nil then
      success = trigger.misc.getUserFlag("Success".. activeTarget[client]) 
    end 

    if target:IsAlive() and aliveUnits > 0 then
      MESSAGE:New("GROUP " .. aliveUnits .. "/" .. clientTargetCount [client], messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 

      if clientTargetCount [client] - aliveUnits > minDestForSuccess and success ~= 1 then 
        MESSAGE:New( "*** BDA ***\nTargets were heavily hit. Destroy the remaining targets or report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)     
        outcome = true
        beepSoundClient:ToGroup(clientGrp)
      end
      SCHEDULER:New( nil, checkTarget, {client}, 10 )
    else
      missionTask[client] = ""
      targetStatus[client] = nil
      deleteMarks(client)

      MESSAGE:New( "*** BDA ***\nAll targets have been destroyed. Task completed, report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)   
      outcome = true
      beepSoundClient:ToGroup(clientGrp)
    end
      
    -- Valorizzo il flag per la rispettiva missione
    if success ~= 1 and outcome == true and activeTarget[client] ~= nil then
      trigger.action.setUserFlag("Success".. activeTarget[client], true) 
      newMenu (client)
    end
  end
end

function checkSceneryTarget (client)
  if targetStatus [client] ~= nil and missionTask[client] == "STRIKE" then
    local clientGrp = client:GetGroup()
    local target  = targetStatus [client]
    MESSAGE:New("TARGET " .. target:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    local originalTargetUnitCount = clientTargetCount[client]
    local actualTargetUnitCount = getAliveStructuresZone(target)
    getDestroyedStructures(target,client)
    local outcome = false 
    local success = false

    if activeTarget[client] ~= nil then
      success = trigger.misc.getUserFlag("Success".. activeTarget[client]) 
    end

    MESSAGE:New("SCENERY " .. actualTargetUnitCount .. "/" .. originalTargetUnitCount, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 

    if actualTargetUnitCount > 0 then
      if originalTargetUnitCount - actualTargetUnitCount > minStructureDestForSuccess and success ~= 1 then 
        MESSAGE:New( "*** BDA ***\nTargets were heavily hit. Destroy the remaining targets or report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)   
        outcome = true
        beepSoundClient:ToGroup(clientGrp)
      end
      SCHEDULER:New( nil, checkSceneryTarget, {client}, 10 )
    else
      missionTask[client] = ""
      targetStatus[client] = nil
      deleteMarks(client)

      MESSAGE:New( "*** BDA ***\nAll targets have been destroyed. Task completed, report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)    
      outcome = true
      beepSoundClient:ToGroup(clientGrp)
    end
    
    -- Valorizzo il flag per la rispettiva missione
    if success ~= 1 and outcome == true and activeTarget[client] ~= nil then
      trigger.action.setUserFlag("Success".. activeTarget[client], true) 
      newMenu (client)
    end
  end
end

function checkStaticTarget (client)
  if targetStatus [client] ~= nil and missionTask[client] == "AIRBASE" then
    local clientGrp = client:GetGroup()
    local target  = targetStatus [client]
    MESSAGE:New("TARGET " .. target:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    local originalTargetUnitCount = clientTargetCount[client]
    local actualTargetUnitCount = getAliveStaticPrefix(target:GetName())
    local outcome = false 
    local success = false

    if activeTarget[client] ~= nil then
      success = trigger.misc.getUserFlag("Success".. activeTarget[client]) 
    end

    MESSAGE:New("STATIC " .. actualTargetUnitCount .. "/" .. originalTargetUnitCount, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 

    if actualTargetUnitCount > 0 then
      if originalTargetUnitCount - actualTargetUnitCount > minDestForSuccess and success ~= 1 then 
        MESSAGE:New( "*** BDA ***\nTargets were heavily hit. Destroy the remaining targets or report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)    
        outcome = true
        beepSoundClient:ToGroup(clientGrp)
      end
      SCHEDULER:New( nil, checkStaticTarget, {client}, 10 )
    else
      missionTask[client] = ""
      targetStatus[client] = nil
      deleteMarks(client)

      MESSAGE:New( "*** BDA ***\nAll targets have been destroyed. Task completed, report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)    
      outcome = true
      beepSoundClient:ToGroup(clientGrp)
    end
    
    -- Valorizzo il flag per la rispettiva missione
    if success ~= 1 and outcome == true and activeTarget[client] ~= nil then
      trigger.action.setUserFlag("Success".. activeTarget[client], true) 
      newMenu (client)
    end
  end
end

function checkConvoyTarget (client)
  if targetStatus [client] ~= nil and missionTask[client] == "CONVOY" then
    local clientGrp = client:GetGroup()
    local target  = targetStatus [client]
    local originalTargetUnitCount = clientTargetCount[client]
    local actualTargetUnitCount = getAliveUnitsSpawn(target)
    local outcome = false 
    local success = false

    if activeTarget[client] ~= nil then
      success = trigger.misc.getUserFlag("Success".. activeTarget[client]) 
    end

    MESSAGE:New("CONVOY UNITS: " .. actualTargetUnitCount .. "/" .. originalTargetUnitCount, messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 

    if actualTargetUnitCount > 0 then
      if originalTargetUnitCount - actualTargetUnitCount > minDestForSuccess and success ~= 1 then 
        MESSAGE:New( "*** BDA ***\nTarget convoy has been heavily hit. Destroy the rest of the convoy or report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)     
        outcome = true
        beepSoundClient:ToGroup(clientGrp)
      end
      SCHEDULER:New( nil, checkConvoyTarget, {client}, 10 )
    else
      missionTask[client] = ""
      targetStatus[client] = nil
      deleteMarks(client)

      MESSAGE:New( "*** BDA ***\nTarget convoy has been completely destroyed. Task completed, report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)    
      outcome = true
      beepSoundClient:ToGroup(clientGrp)
    end
    
    -- Valorizzo il flag per la rispettiva missione
    if success ~= 1 and outcome == true and activeTarget[client] ~= nil then
      trigger.action.setUserFlag("Success".. activeTarget[client], true) 
      newMenu (client)
    end
  end
end

function checkRunwayTarget (client)
  MESSAGE:New("Check Runway bombing stared", 5 ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)    
  local clientGrp = client:GetGroup()
  clientGrp:HandleEvent( EVENTS.Shot )
  function clientGrp:OnEventShot( EventData )
    local eventdata = EventData
  
    -- Nil check if we have a weapon in the eventdata table.
    if eventdata and eventdata.weapon then
  
      -- Debug info.
      MESSAGE:New( "Captured Weapon " .. eventdata.IniUnitName, 5 ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 

      -- Create a new WEAPON object from the DCS weapon object in the event data.
      local weapon = WEAPON:New( eventdata.weapon )

      -- Set which function to call.
      weapon:SetFuncImpact(OnImpact, client)
  
      -- Mark impact point on F10 map.
      --weapon:SetMarkImpact( true )
  
      -- Smoke impact point.
      --weapon:SetSmokeImpact( true )
  
      -- Start tracking the weapon.
      weapon:StartTrack()
    end
  end
end

function OnImpact(Weapon, client)
  if targetStatus [client] ~= nil and missionTask[client] == "RUNWAY" then
    MESSAGE:New( "CLIENT " .. client:GetName(), 5 ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    MESSAGE:New( "LAUNCHER " .. Weapon:GetLauncher():GetName(), 5 ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
    
    if Weapon:GetLauncher():GetName() == client:GetName() and Weapon:IsBomb() then
      local target = targetStatus [client]

      if target:IsCoordinateInZone(Weapon:GetImpactCoordinate()) then
        clientTargetHits [client] = clientTargetHits [client] + 1
        --MESSAGE:New( "HIT in zone - tot " .. clientTargetHits [client], 5 ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 

        local outcome = false 
        local success = false

        if activeTarget[client] ~= nil then
          success = trigger.misc.getUserFlag("Success".. activeTarget[client]) 
        end

        if clientTargetHits [client]>=minRunwayBombs1 and success ~= 1 then
          MESSAGE:New( "*** BDA ***\nTarget runway has been severely hit. Bomb the runway again to make it completely unusable or report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)
          trigger.action.setUserFlag("AnsirialLBSceneryDest".. logbookSplitter .. "Runway", true)    
          outcome = true
          beepSoundClient:ToGroup(clientGrp)
        end

        -- qui il messaggio potrebbe essere ripetuto... verificare
        if clientTargetHits [client]>=minRunwayBombs2 then
          missionTask[client] = ""
          targetStatus[client] = nil
          clientTargetHits [client] = nil
          clientTargetCount[client] = 0
          deleteMarks(client)

          MESSAGE:New( "*** BDA ***\nTarget runway is completely unusable. Task completed, report your status to ASOC via radio menu.", clientTime, nil ):ToClient(client)     
          outcome = true
          beepSoundClient:ToGroup(clientGrp)
        end
        
        -- Valorizzo il flag per la rispettiva missione
        if success ~= 1 and outcome == true and activeTarget[client] ~= nil then
          trigger.action.setUserFlag("Success".. activeTarget[client], true) 
          newMenu (client)
        end
      end
    end
  end
end

-- MENU FUNCTIONS
function newMenu (client)

  if initMission then

    local clientGrp  = client:GetGroup()
    local success = false

    if activeTarget[client] ~= nil then
      success = trigger.misc.getUserFlag("Success".. activeTarget[client]) 
    end
      
    -- REMOVE OLD MENU
    for k,v in pairs(menuItems[client]) do
      local menuItem = menuItems[client][k]
      if menuItem ~= nil then
        menuItem:Remove()
      end
    end

    menuItems[client] = {}

    --local menuItem = menuItems[client]
    --if menuItem ~= nil then
    --  menuItem:Remove()
    --end
   
    -- MENU 
    --local missionMenu = MENU_GROUP:New( clientGrp, "Mission control" )  
    --menuItems[client] = missionMenu

    local missionMenu = nil  

    -- SHOW PROGRESS
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Show mission context",  nil, getStageInfo, client )
    table.insert(menuItems[client],missionMenu)    
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Show coalition flights",  nil, showCoalitionFlights, client ) 
    table.insert(menuItems[client],missionMenu)
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Show coalition targets",  nil, showCoalitionTargets, client )
    table.insert(menuItems[client],missionMenu)

    --if picturesUpdate [client] then  
    --  missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Disable continuous picture updates",  nil, disablePictureUpdates, client )
    --  table.insert(menuItems[client],missionMenu)    
    --else
    --  missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Enable continuous picture updates",  nil, enablePictureUpdates, client )
    --  table.insert(menuItems[client],missionMenu) 
    --end
    
   -- CHIAMATA PER ON STATION
   if callOnStation[client] ~= true and onStationVisibility [client] == true and targetStatus[client] == nil and (missionTask[client] == "ARMOR" or missionTask[client] == "ARTILLERY" or missionTask[client] == "FORCE" or missionTask[client] == "BASE" or missionTask[client] == "CONVOY") then
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Call on station",  nil, onStation, client )
    table.insert(menuItems[client],missionMenu)
  end

  -- Chiamata per task completed
  if success == 1 and ASOCTaskCompleted[client] ~= true then
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Report to ASOC the completion of the task",  nil, taskCompleted, client )
    table.insert(menuItems[client],missionMenu)
  end

  -- OPZIONI SENZA TARGET ASSEGNATO 
    if (missionTask[client] == nil or missionTask[client] == "") and ASOCTaskCompleted[client] == true and isWinchester[client] ~= true and waitingTasking[client] ~= true then
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Report to ASOC you are available for a task",  nil, fn_GetTarget, client )
    table.insert(menuItems[client],missionMenu)
  end

  -- Chiamata Bingo Fuel
  if isWinchester[client] ~= true and waitingTasking[client] ~= true and inAir[client] == true then
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Report Bingo fuel to ASOC",  nil, bingo, client )
    table.insert(menuItems[client],missionMenu)
  end

  -- Chiamata Winchester
  if isWinchester[client] ~= true and waitingTasking[client] ~= true and inAir[client] == true then
    missionMenu = MENU_GROUP_COMMAND:New( clientGrp, "Report Winchester to ASOC",  nil, winchester, client )
    table.insert(menuItems[client],missionMenu)
  end
  
 -- TARGET MENU OBSOLETO
    if false then      

      -- GROUND TARGET MENU           
      local groundTargetMenu = MENU_GROUP:New( clientGrp, "Select ground target", nil)
      table.insert(menuItems[client],groundTargetMenu)      
       
       -- NEAREST GROUND TARGET
      local nearestMenu = MENU_GROUP:New( clientGrp, "Nearest", groundTargetMenu)
      MENU_GROUP_COMMAND:New( clientGrp, "Any target",  nearestMenu, fn_GroundTARGET, client, "ANY", "NEAREST" )
      MENU_GROUP_COMMAND:New( clientGrp, "SAM target",  nearestMenu, fn_GroundTARGET, client, "SAM", "NEAREST" )
      MENU_GROUP_COMMAND:New( clientGrp, "Armor target",   nearestMenu, fn_GroundTARGET, client, "ARMOR", "NEAREST" )
      MENU_GROUP_COMMAND:New( clientGrp, "Air Defence target",   nearestMenu, fn_GroundTARGET, client, "AIR DEFENCE", "NEAREST" )
      MENU_GROUP_COMMAND:New( clientGrp, "Artillery target",    nearestMenu, fn_GroundTARGET, client, "ARTILLERY", "NEAREST" )  
      MENU_GROUP_COMMAND:New( clientGrp, "BASE target",    nearestMenu, fn_GroundTARGET, client, "BASE", "NEAREST" )
      MENU_GROUP_COMMAND:New( clientGrp, "Supply convoy target",    nearestMenu, fn_GroundTARGET, client, "CONVOY", "NEAREST" )
      MENU_GROUP_COMMAND:New( clientGrp, "Strike target",    nearestMenu, fn_ConvoyTARGET, client )
  
       -- RANDOM GROUND TARGET          
      local randomMenu = MENU_GROUP:New( clientGrp, "Random", groundTargetMenu) 
      MENU_GROUP_COMMAND:New( clientGrp, "Any target",  randomMenu, fn_GroundTARGET, client, "ANY", "RANDOM" )
      MENU_GROUP_COMMAND:New( clientGrp, "SAM target",  randomMenu, fn_GroundTARGET, client, "SAM", "RANDOM" )
      MENU_GROUP_COMMAND:New( clientGrp, "Armor target",   randomMenu, fn_GroundTARGET, client, "ARMOR", "RANDOM" )
      MENU_GROUP_COMMAND:New( clientGrp, "Air Defence target",   randomMenu, fn_GroundTARGET, client, "AIR DEFENCE", "RANDOM" )
      MENU_GROUP_COMMAND:New( clientGrp, "Artillery target",    randomMenu, fn_GroundTARGET, client, "ARTILLERY", "RANDOM" )  
      MENU_GROUP_COMMAND:New( clientGrp, "BASE target",    randomMenu, fn_GroundTARGET, client, "BASE", "RANDOM" )
      MENU_GROUP_COMMAND:New( clientGrp, "Supply convoy target",    randomMenu, fn_GroundTARGET, client, "CONVOY", "RANDOM" )
      MENU_GROUP_COMMAND:New( clientGrp, "Strike target",    randomMenu, fn_ConvoyTARGET, client )
  
      -- AIR TARGET MENU        
      local airTargetMenu = MENU_GROUP:New( clientGrp, "Select air target", nil)
      table.insert(menuItems[client],airTargetMenu)  
      MENU_GROUP_COMMAND:New( clientGrp, "Nearest target",  airTargetMenu, fn_AirTARGET, client, "NEAREST" )
      MENU_GROUP_COMMAND:New( clientGrp, "Random target",  airTargetMenu, fn_AirTARGET, client, "RANDOM" )                   
      
    end

    -- Al momento la missione si autoassegna
    --if targetStatus[client] == nil then      
      -- ASSIGN A MISSION  
    --  MENU_GROUP_COMMAND:New( clientGrp, "Get a mission",  missionMenu, fn_GetTarget, client )
    --else

    -- OBIETTIVO ASSEGNATO (JTAC e BASI)
    if targetStatus[client] ~= nil and missionTask[client] ~= "CAP" and missionTask[client] ~= "CONVOY" and missionTask[client] ~= "RUNWAY" and missionTask[client] ~= "STRIKE" and missionTask[client] ~= "AIRBASE" then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu) 
      
      MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, showGroundTargetInfo, client )
      MENU_GROUP_COMMAND:New( clientGrp, "Get coordinates",  targetMenu, showJDAMcoord, client )           
    end
    
    -- OBIETTIVO ASSEGNATO (STRIKE)
    if targetStatus[client] ~= nil and missionTask[client] ~= "CAP" and missionTask[client] == "STRIKE"  then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu) 
      
      MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, showStructureTargetInfo, client ) 
      MENU_GROUP_COMMAND:New( clientGrp, "Get coordinates",  targetMenu, showJDAMcoord, client )           
    end

    -- OBIETTIVO ASSEGNATO (CONVOY)
    if targetStatus[client] ~= nil and missionTask[client] ~= "CAP" and missionTask[client] == "CONVOY"  then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu) 
      
      MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, showConvoyTargetInfo, client )     
    end

    if targetStatus[client] ~= nil and missionTask[client] ~= "CAP" and missionTask[client] == "AIRBASE"  then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu) 
      
      MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, showStaticTargetInfo, client )     
    end

    if targetStatus[client] ~= nil and not string.starts(clientGrp:GetName(), "CAP") and missionTask[client] == "RUNWAY"  then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu) 
      
      MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, showRunwayTargetInfo, client )           
    end

    -- OBIETTIVO ASSEGNATO (CAP)
    if targetStatus[client] ~= nil and missionTask[client] == "CAP" then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu)
      
      MENU_GROUP_COMMAND:New( clientGrp, "Target information",  targetMenu, showAirTargetInfo, client )                
      --MENU_GROUP_COMMAND:New( clientGrp, "Change target",  targetMenu, changeTarget, client )
    end

    -- OBIETTIVO NON ASSEGNATO (CAP)
    if targetStatus[client] == nil and missionTask[client] == "CAP" and Success1 == 0 and Success2 == 0 then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu)
      MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, fn_GetTarget, client )                      
    end
    
    -- OBIETTIVO NON ASSEGNATO (XCAS e XAI)
    if targetStatus[client] == nil and (missionTask[client] == "FORCE" or missionTask[client] == "BASE" or missionTask[client] == "ARMOR" or missionTask[client] == "ARTILLERY" or missionTask[client] == "CONVOY") then      
      -- TARGET INFORMATION
      local targetMenu = MENU_GROUP:New( clientGrp, "Target menu", nil)
      table.insert(menuItems[client],targetMenu)

      if missionTask[client] == "CONVOY" then
        MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, fn_XConvoyTARGET, client )
      else
        MENU_GROUP_COMMAND:New( clientGrp, "Mission briefing",  targetMenu, fn_XGroundTARGET, client )
      end
    end
    
    -- MENU OPZIONI
    local messageMenu = MENU_GROUP:New( clientGrp, "Options", nil)  
    table.insert(menuItems[client],messageMenu) 

    if missionTask[client] ~= nil and missionTask[client] ~= "" and isWinchester[client] ~= true and waitingTasking[client] ~= true then         
      MENU_GROUP_COMMAND:New( clientGrp, "Ask ASOC to change task",  messageMenu, changeTarget, client )
    end

    -- GESTIONE DEI MESSAGGI ADDIZIONALI
    if messageStatus [client] then  
      MENU_GROUP_COMMAND:New( clientGrp, "Disable additional messages",  messageMenu, fn_disableMessages, client )
      --table.insert(menuItems[client],missionMenu)    
    else
      MENU_GROUP_COMMAND:New( clientGrp, "Enable additional messages",  messageMenu, fn_enableMessages, client )
      --table.insert(menuItems[client],missionMenu)  
    end    
             
  else
    SCHEDULER:New( nil, newMenu, {client}, 1 )  
  end 
end

function string.starts(String,Start)
  return string.sub(String,1,string.len(Start))==Start
end

function fn_GetTarget(client)
  local side = nil
  if client:GetCoalition() == 1 then side = "red" opfor = "blue" end
  if client:GetCoalition() == 2 then side = "blue" opfor = "red" end

  ASOCTaskCompleted[client] = false
  targetStatus[client] = nil
  missionTask[client] = selectTask(side, client)

  if activeTarget[client] == 0 then 
    activeTarget[client] = 1
  end

  -- Variabili Logbook
  trigger.action.setUserFlag("AnsirialLBMission".. logbookSplitter .. logbookMission, true) 
  trigger.action.setUserFlag("AnsirialLBTask".. logbookSplitter .. missionTask[client], true) 

  if opfor == "blue" then
    trigger.action.setUserFlag("AnsirialLBEnemy".. logbookSplitter .. blueCode, true)
  end

  if opfor == "red" then
    trigger.action.setUserFlag("AnsirialLBEnemy".. logbookSplitter .. redCode, true)
  end
  -- fine Logbook

  callOnStation[client] = false

  if missionTask[client] == "SAM" or missionTask[client] == "FORCE" or missionTask[client] == "BASE" or missionTask[client] == "ARMOR" or missionTask[client] == "AIR DEFENCE" or missionTask[client] == "ARTILLERY" or missionTask[client] == "CONVOY" then
    
    local coin = math.random(1,100)

    if coin > 70 then
      -- 30% GCAS + Scheduled CAS
      if missionTask[client] == "CONVOY" then
        fn_ConvoyTARGET(client)
      else
        fn_GroundTARGET(client, missionTask[client], "NEAREST")
      end
    else
      -- 70% XCAS
      if missionTask[client] == "CONVOY" then
        fn_XConvoyTARGET(client)
      else
        fn_XGroundTARGET(client)
      end
    end
        
    newMenu (client)
  end

  if missionTask[client] == "CAP" then
    MESSAGE:New( "*** MISSION: CAP ***\nTakeoff and proceed on course heading between waypoints 1 and 2. You may be contacted by GCI for interception if needed", clientTime, nil ):ToClient(client) 
    local clientGrp = client:GetGroup()
    beepSoundClient:ToGroup(clientGrp)   
  end

  if missionTask[client] == "STRIKE" then
    fn_SceneryTARGET(client, "RANDOM")
  end

  if missionTask[client] == "AIRBASE" then
    fn_StaticAirbaseTARGET(client, "RANDOM")
  end

  if missionTask[client] == "RUNWAY" then
    fn_RunwayTARGET(client, "RANDOM")
  end
end

function fn_checkAirTARGET(client, where)  
  local target = targetStatus [client]

  if target == nil then
    SCHEDULER:New( nil, fn_checkAirTARGET, {client,where}, 30 )
    local side = nil
    local opfor = nil

    if client:GetCoalition() == 1 then side = "red" opfor = "blue" end
    if client:GetCoalition() == 2 then side = "blue" opfor = "red" end

    if getAirbornGroups(opfor) > 0 then  
      -- GET TARGET 
      local targetset = {}

      for grp,grpInfo in pairs(airGroups) do   
        local grpSide = grpInfo["side"]
        if side ~= grpSide then
          table.insert(targetset, grp)     
        end
      end

      for i = 1, #targetset do
        local clientCoord = client:GetCoordinate()
        local targetCoord = targetset[i]:GetCoordinate()

        if clientCoord:Get2DDistance(targetCoord)<metersDistanceToIntercept*1000 then
          SCHEDULER:New( nil, fn_AirTARGET, {client,where}, 1 )
          break
        end
      end
    end
  end
end

function fn_AirTARGET(client, where)
  local clientGrp = client:GetGroup()
  local clientPos = clientGrp:GetPointVec2()

  local side = nil
  local opfor = nil
  if client:GetCoalition() == 1 then side = "red" opfor = "blue" end
  if client:GetCoalition() == 2 then side = "blue" opfor = "red" end

  if getAirbornGroups(opfor) > 0 then  
    -- GET TARGET
    local targetset = {}
    local nearestTarget = nil
    local randomTarget = nil
    local closestDistance = nil  
    for grp,grpInfo in pairs(airGroups) do   
      local grpSide = grpInfo["side"]
      if side ~= grpSide then
        table.insert(targetset, grp) 
        if nearestTarget == nil then
          nearestTarget = grp
          closestDistance = clientPos:DistanceFromPointVec2( grp:GetCoordinate() )
        else
          local distance = clientPos:DistanceFromPointVec2( grp:GetCoordinate() )
          if distance < closestDistance then
            nearestTarget = grp
            closestDistance = distance
          end                      
        end     
      end
    end

    if where == "NEAREST" then
      targetStatus [client] = nearestTarget
      clientTargetCount[client] = getAliveUnitsGrp(targetStatus [client])
    end
      
    if where == "RANDOM" then
      randomTarget = targetset[math.random(#targetset)]
      targetStatus [client] = randomTarget
      clientTargetCount [client] = getAliveUnitsGrp(targetStatus [client])      
    end
    checkTarget (client)

    -- RESET MENU
    newMenu (client)

    -- MSG    
    showAirTargetInfo (client)       
  else
    trigger.action.setUserFlag("Success1", true) 
    trigger.action.setUserFlag("Success2", true) 
    -- MSG   
    MESSAGE:New( "*** MISSION UPDATE ***\nSituation is clean\nYour are creared to RTB", clientTime, nil ):ToClient(client)
    beepSoundClient:ToGroup(clientGrp)
  end  
end

function fn_XGroundTARGET(client)
  MESSAGE:New("*** MISSION: XCAS ***\nEstablish an orbit at waypoint 1. Contact ASOC once on station via radio menu and wait for tasking.", clientTime, nil ):ToClient(client)
  local clientGrp = client:GetGroup()
  beepSoundClient:ToGroup(clientGrp)
end

function fn_GroundTARGET(client, task, where)
  local clientGrp = client:GetGroup()
  local side = nil
  if client:GetCoalition() == 1 then side = "red" end
  if client:GetCoalition() == 2 then side = "blue" end

  targetStatus[client] = getTarget (side, task, clientGrp)
  waitingTasking[client] = false
  
  SCHEDULER:New( nil, function() 
    clientTargetCount[client] = getAliveUnitsGrp(targetStatus[client])
  end , {}, 10 )

  local JTACcallsign = nil
  local JTACName = nil
  local JTACFreq = nil

  -- Rimuovo eventuali JTAC di questo client
  if targetJTACs[client] ~= nil then
    targetJTACs[client]:Destroy(false)
    targetJTACs[client] = nil 
    JTACNames [client] = nil
    JTACFreqs [client] = nil
  end

  if task ~= "BASE" then
    JTACcallsign = math.random(1, 9)

    if JTACcallsign == 1 then JTACName = "Axeman" JTACFreq = 133 end -- ok
    if JTACcallsign == 2 then JTACName = "Darknight" JTACFreq = 134 end
    if JTACcallsign == 3 then JTACName = "Warrior" JTACFreq = 135 end
    if JTACcallsign == 4 then JTACName = "Pointer" JTACFreq = 136 end
    if JTACcallsign == 5 then JTACName = "Eyeball" JTACFreq = 137 end	
    if JTACcallsign == 6 then JTACName = "Moonbeam" JTACFreq = 138 end	
    if JTACcallsign == 7 then JTACName = "Whiplash" JTACFreq = 139 end	
    if JTACcallsign == 8 then JTACName = "Finger" JTACFreq = 140 end	
    if JTACcallsign == 9 then JTACName = "Pinpoint" JTACFreq = 141 end	

    jtac = spawn_BLUE_JTAC:SpawnFromVec2(COORDINATE:NewFromVec2(targetStatus [client]:GetVec2()):GetRandomVec2InRadius(maxJTACdistance, minJTACdistance))
    local task = jtac:TaskFAC_AttackGroup(targetStatus [client], 3221225470, AI.Task.Designation.AUTO, true, JTACFreq, 0, JTACcallsign, 1)
    jtac:SetTask(task, 10)
    targetJTACs [client] = jtac
    JTACNames [client] = JTACName
    JTACFreqs [client] = JTACFreq
  end

  SCHEDULER:New( nil, checkTarget, {client}, 20 )
    
  -- RESET MENU
  newMenu (client) 
          
  -- MSG    
  showGroundTargetInfo (client) 
end

-- Assegna un obiettivo di tipo struttura
function fn_SceneryTARGET(client, where)
  local clientGrp = client:GetGroup()
  local side = nil
  if client:GetCoalition() == 1 then side = "red" opfor = "blue" end
  if client:GetCoalition() == 2 then side = "blue" opfor = "red" end

  targetStatus [client] = getTarget (side, "STRIKE", clientGrp)

  -- CALCOLO IL TOTALE DELLE STRUTTURE NELLA ZONA
  clientTargetCount[client] = SET_SCENERY:NewFromZone(targetStatus [client]):FilterOnce():Count()

  checkSceneryTarget (client) 
    
  -- RESET MENU
  newMenu (client) 
          
  -- MSG
  showStructureTargetInfo (client) 
end

function fn_StaticAirbaseTARGET(client, where)
  local clientGrp = client:GetGroup()
  local side = nil
  if client:GetCoalition() == 1 then side = "red" opfor = "blue" end
  if client:GetCoalition() == 2 then side = "blue" opfor = "red" end

  targetStatus [client] = getTarget (side, "AIRBASE", clientGrp)
  -- CALCOLO IL TOTALE DELLE STRUTTURE NELLA ZONA
  clientTargetCount[client] = SET_STATIC:New():FilterPrefixes(targetStatus [client]:GetName()):FilterOnce():Count()
  
  checkStaticTarget (client) 
    
  -- RESET MENU
  newMenu (client) 
          
  -- MSG
  showStaticTargetInfo (client) 
end

-- Assegna un obiettivo di tipo runway
function fn_RunwayTARGET(client, where)
  local clientGrp = client:GetGroup()
  local side = nil
  if client:GetCoalition() == 1 then side = "red" opfor = "blue" end
  if client:GetCoalition() == 2 then side = "blue" opfor = "red" end

  targetStatus [client] = getTarget (side, "RUNWAY", clientGrp)
  clientTargetHits [client] = 0
  clientTargetCount[client] = 1
  checkRunwayTarget (client) 
    
  -- RESET MENU
  newMenu (client) 
          
  -- MSG
  showRunwayTargetInfo (client) 
end

function fn_XConvoyTARGET(client)
  MESSAGE:New("*** MISSION: XAI ***\nEstablish an orbit at waypoint 1. Contact ASOC once on station via radio menu and wait for tasking.", clientTime, nil ):ToClient(client)
  local clientGrp = client:GetGroup()
  beepSoundClient:ToGroup(clientGrp)
end

-- Crea e assegna un obiettivo di tipo convoy
function fn_ConvoyTARGET(client)
  local clientGrp = client:GetGroup()
  local template = nil
  local side = nil
  local randomOrigZone = nil
  local randomDestZone = nil

  if client:GetCoalition() == 1 then
    --side = "BLUE"
    --template = BLUE_CONVOYS
    --randomOrigZone = BLUE_CONVOY_ORIGIN_ZONES:GetRandomSurely()
    --randomDestZone = BLUE_CONVOY_DESTINATION_ZONES:GetRandomSurely()
  end
  
  if client:GetCoalition() == 2 then
    side = "RED"
    template = RED_CONVOYS

        -- Va trovato un modo per prendere un convoy vicino al WP1
    local combination = math.random(1,4)

    if combination == 1 then
      randomOrigZone = RED_CONVOY_N_ZONES:GetRandomSurely()
      randomDestZone = RED_CONVOY_C_ZONES:GetRandomSurely()
    end

    if combination == 2 then
      randomOrigZone = RED_CONVOY_C_ZONES:GetRandomSurely()
      randomDestZone = RED_CONVOY_N_ZONES:GetRandomSurely()
    end

    if combination == 3 then
      randomOrigZone = RED_CONVOY_S_ZONES:GetRandomSurely()
      randomDestZone = RED_CONVOY_C_ZONES:GetRandomSurely()
    end

    if combination == 4 then
      randomOrigZone = RED_CONVOY_C_ZONES:GetRandomSurely()
      randomDestZone = RED_CONVOY_S_ZONES:GetRandomSurely()
    end
  end

  local spawn_CONVOY = SPAWN:New(side .. " CONVOY")
  :InitRandomizeTemplate(template)
  :InitLimit( 25, 25 )
  :InitPositionVec2(randomOrigZone:GetVec2())
  :OnSpawnGroup(
  function( SpawnGroup )    
    SpawnGroup:TaskRouteToZone( randomDestZone, true, 16, "On Road") -- 60 km/h

    local grpUnits = SpawnGroup:GetUnits()
    for i = 1, #grpUnits do
      local Unit = SpawnGroup:GetUnit( i )
      SCHEDULER:New( nil, cleanupGroundUnitOnInit, {Unit, SpawnGroup}, 10 ) 
      SCHEDULER:New( nil, cleanupGroundUnitOnInit, {Unit, SpawnGroup}, 20 )
      SCHEDULER:New( nil, cleanupGroundUnitOnInit, {Unit, SpawnGroup}, 30 )
    end

  end)

  local grp = spawn_CONVOY:SpawnScheduled( 2, 0 )
  MESSAGE:New( side .. " CONVOY generation started...", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)

  targetStatus[client] = spawn_CONVOY
  waitingTasking[client] = false

  SCHEDULER:New( nil, function() 
    if missionTask[client] == "CONVOY" then    
      clientTargetCount[client] = getAliveUnitsSpawn(spawn_CONVOY)
      checkConvoyTarget(client)

      -- RESET MENU
      newMenu (client) 
    end
  end , {}, 120 )

  -- MSG  
  SCHEDULER:New( nil, showConvoyTargetInfo , {client}, 10 )
end

function cleanupGroundUnitOnInit (unit, grp)
  if unit:IsAlive() then
    local newVec2 = unit:GetVec2()
    if unit:GetVelocityKMH() < 1 then
      unit:Destroy()
      MESSAGE:New( unit:GetName() .. " is removed by cleanup script", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)     
    end
  end
end

-- DEFINE MISSION - Deprecata
function generateDynamic(side, type, zoneName)
  SpawnZone = ZONE:FindByName(zoneName)
  if type ~= "Smoke" then
    local grp = nil
    if side == "red" then
      if type == "Armor" then
        grp = spawn_RED_ARMOR:SpawnInZone(SpawnZone)
      end
      if type == "Arty" then
        grp = spawn_RED_ARTILLERY:SpawnInZone(SpawnZone)
      end
      if type == "Base" then
        grp = spawn_RED_BASE:SpawnInZone(SpawnZone)
      end
    end
    if side == "blue" then
      if type == "Armor" then
        grp = spawn_BLUE_ARMOR:SpawnInZone(SpawnZone)
      end
      if type == "Arty" then
        grp = spawn_BLUE_ARTILLERY:SpawnInZone(SpawnZone)
      end
      if type == "Base" then
        grp = spawn_BLUE_BASE:SpawnInZone(SpawnZone)
      end
    end
    removeUnitPositions (grp)
    return grp
  end

  if type == "Smoke" then
    SpawnZone:GetPointVec2():BigSmokeHuge(0.5)
  end
end

-- Deprecata
function setStage(location)
  --Inherent Resolve Stage setup
  MESSAGE:New( "Stage generation...", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  
  local red_bases = SET_ZONE:New()
  :FilterPrefixes("Base%-ISIS%-" .. location)
  :FilterOnce()
  red_bases:ForEachZone(function(ZONE)                
    generateDynamic("red", "Base", ZONE:GetName())
  end)

  local red_armors = SET_ZONE:New()
  :FilterPrefixes("Armor%-ISIS%-" .. location )
  :FilterOnce()
  red_armors:ForEachZone(function(ZONE)                  
    generateDynamic("red", "Armor", ZONE:GetName())
  end)

  local red_artys = SET_ZONE:New()
  :FilterPrefixes("Arty%-ISIS%-" .. location )
  :FilterOnce()
  red_artys:ForEachZone(function(ZONE)                  
    generateDynamic("red", "Arty", ZONE:GetName())
  end)

  local blue_armors = SET_ZONE:New()
  :FilterPrefixes("Armor%-COA%-" .. location )
  :FilterOnce()
  blue_armors:ForEachZone(function(ZONE)                  
    generateDynamic("blue", "Armor", ZONE:GetName())
  end)
end

function getStageInfo (client)
  if initMission then
    local clientGrp = client:GetGroup()

    local mainTitle = "*** OPERATION INHERENT RESOLVE ***\n"
    local date = "November 2015\n"

    MESSAGE:New( mainTitle .. date .. "In response to the threat posed by ISIS, a multinational coalition has formed, led by the United States and supported by allies like the UK, France, and Germany, as well as regional partners such as Iraq and Kurdish forces.\n\nHowever, tensions exist with Russian Federation, which has established a no-fly zone in certain areas. Pilots must avoid breaching this zone to prevent military and diplomatic consequences while conducting operations against ISIS.", clientTime, nil ):ToClient(client)
    beepSoundClient:ToGroup(clientGrp)
  else
    SCHEDULER:New( nil, getStageInfo, {client}, 1 )  
  end  
end

do -- PREPARE RED SPAWNS
  --spawn_RED_SAM = SPAWN:New("RED SAM")
  --:InitRandomizeTemplate(RED_SAMS)
  --:InitSkill(AIskillRED)

  spawn_RED_AIRBASE_DEFENCE = SPAWN:New("RED AIRBASE AIR DEFENCE")
  :InitRandomizeTemplate(RED_AIR_DEFENCES)
  :InitRandomizeUnits(true, airbaseRadius)
  :InitSkill(AIskillRED)

  spawn_RED_TMP_AIR_DEFENCE = SPAWN:New("RED TMP AIR DEFENCE")
  :InitRandomizeTemplate(RED_TMP_AIR_DEFENCES)
  :InitRandomizeUnits(true, airDefenceRadius)
  :InitSkill(AIskillRED)

  spawn_RED_ARMOR = SPAWN:New("RED ARMOR")
  :InitRandomizeTemplate(RED_ARMORS)
  :InitRandomizeUnits(true, dynamicZoneRadius)
  :InitSkill(AIskillRED)

  spawn_RED_ARTILLERY = SPAWN:New("RED ARTILLERY")
  :InitRandomizeTemplate(RED_ARTILLERIES)
  :InitRandomizeUnits(true, dynamicZoneRadius)
  :InitSkill(AIskillRED)

  spawn_RED_BASE = SPAWN:New("RED BASE-1")
  --:InitRandomizeTemplate({"RED BASE-1"})
  --:InitRandomizeUnits(true, airbaseRadius)
  :InitSkill(AIskillRED)

  --spawn_RED_SEAD = SPAWN:New("RED SEAD")
  --:InitRandomizeTemplate(RED_SEADS)   
  --:InitSkill(AIskillRED)

  spawn_RED_CAS = SPAWN:New("RED CAS")
  :InitRandomizeTemplate(RED_CASSES) 
  :InitSkill(AIskillRED)

  spawn_RED_CAP = SPAWN:New("RED CAP")
  :InitRandomizeTemplate(RED_CAPS) 
  :InitSkill(AIskillRED)
end

do -- PREPARE BLUE SPAWNS
  --spawn_BLUE_SAM = SPAWN:New("BLUE SAM")
  --:InitRandomizeTemplate(BLUE_SAMS)
  --:InitSkill(AIskillBLUE)

  spawn_BLUE_AIRBASE_DEFENCE = SPAWN:New("BLUE AIRBASE AIR DEFENCE")
  :InitRandomizeTemplate(BLUE_AIR_DEFENCES)
  :InitRandomizeUnits(true, airbaseRadius)
  :InitSkill(AIskillBLUE)

  spawn_BLUE_TMP_AIR_DEFENCE = SPAWN:New("BLUE TMP AIR DEFENCE")
  :InitRandomizeTemplate(BLUE_TMP_AIR_DEFENCES)
  :InitRandomizeUnits(true, airDefenceRadius)
  :InitSkill(AIskillBLUE)

  spawn_BLUE_ARMOR = SPAWN:New("BLUE ARMOR")
  :InitRandomizeTemplate(BLUE_ARMORS)
  :InitRandomizeUnits(true, dynamicZoneRadius)
  :InitSkill(AIskillBLUE)

  spawn_BLUE_JTAC = SPAWN:New("BLUE JTAC")
  :InitRandomizeTemplate(BLUE_JTACS) 
  :InitSkill(AIskillBLUE)

  spawn_BLUE_ARTILLERY = SPAWN:New("BLUE ARTILLERY")
  :InitRandomizeTemplate(BLUE_ARTILLERIES)
  :InitRandomizeUnits(true, dynamicZoneRadius)
  :InitSkill(AIskillBLUE)

  --spawn_BLUE_BASE = SPAWN:New("BLUE BASE-1")
  --:InitRandomizeTemplate({"BLUE BASE-1"})
  --:InitRandomizeUnits(true, airbaseRadius)
  --:InitSkill(AIskillBLUE)

  spawn_BLUE_SEAD = SPAWN:New("BLUE SEAD")
  :InitRandomizeTemplate(BLUE_SEADS)   
  :InitSkill(AIskillBLUE)

  spawn_BLUE_CAS = SPAWN:New("BLUE CAS")
  :InitRandomizeTemplate(BLUE_CASSES)
  :InitSkill(AIskillBLUE)

  spawn_BLUE_CAP = SPAWN:New("BLUE CAP")
  :InitRandomizeTemplate(BLUE_CAPS) 
  :InitSkill(AIskillBLUE)

  spawn_BLUE_SEAD_CVN = SPAWN:New("BLUE SEAD")
  :InitRandomizeTemplate(BLUE_SEADS_CVN)   
  :InitSkill(AIskillBLUE)

  spawn_BLUE_CAS_CVN = SPAWN:New("BLUE CAS CVN")
  :InitRandomizeTemplate(BLUE_CASSES_CVN)
  :InitSkill(AIskillBLUE)

  spawn_BLUE_CAP_CVN = SPAWN:New("BLUE CAP CVN")
  :InitRandomizeTemplate(BLUE_CAPS_CVN) 
  :InitSkill(AIskillBLUE)

  spawn_BLUE_TANKER_SHELL = SPAWN:New("BLUE TANKER SHELL")
  :SpawnAtAirbase( AIRBASE:FindByName( AIRBASE.Syria.Incirlik ), SPAWN.Takeoff.Runway )

  spawn_BLUE_TANKER_ARCO = SPAWN:New("BLUE TANKER ARCO")
  :SpawnAtAirbase( AIRBASE:FindByName( AIRBASE.Syria.Incirlik ), SPAWN.Takeoff.Runway )

  --spawn_BLUE_AWACS= SPAWN:New("BLUE AWACS")
  --:SpawnAtAirbase( AIRBASE:FindByName( AIRBASE.Syria.Incirlik ), SPAWN.Takeoff.Runway )
end

do -- FIND ALL TOWNS
  ALL_TOWN_SET = SET_ZONE:New()
  :FilterPrefixes( "Geo " )
  :FilterOnce()
end

do -- ZONE CAS
  RED_ARMOR_ZONES = SET_ZONE:New()
  :FilterPrefixes("Armor%-ISIS%-")
  :FilterOnce()

  RED_ARTY_ZONES = SET_ZONE:New()
  :FilterPrefixes("Arty%-ISIS%-")
  :FilterOnce()

  RED_BASE_ZONES = SET_ZONE:New()
  :FilterPrefixes("Base%-ISIS%-")
  :FilterOnce()

  BLUE_ARMOR_ZONES = SET_ZONE:New()
  :FilterPrefixes("Armor%-COA%-")
  :FilterOnce()
end

do -- ZONE DEI CONVOGLI ROSSI
  RED_CONVOY_N_ZONES = SET_ZONE:New()
  :FilterPrefixes( "RED CONVOY N" )
  :FilterOnce()

  RED_CONVOY_C_ZONES = SET_ZONE:New()
  :FilterPrefixes( "RED CONVOY C" )
  :FilterOnce()

  RED_CONVOY_S_ZONES = SET_ZONE:New()
  :FilterPrefixes( "RED CONVOY S" )
  :FilterOnce()
end
 
do -- FIND ALL AIRBASES
  ALL_AIRBASE_SET = SET_AIRBASE:New()
  :FilterOnce()
  ALL_AIRBASE_SET:RemoveAirbasesByName({"Blue Escort #001","Blue Escort #002","Blue Escort #003","Blue Escort #004"})
end
 
do -- FIND RED AIRBASES
  RED_AIRBASE_SET = SET_AIRBASE:New()
  :FilterCoalitions("red")
  :FilterOnce()
  RED_AIRBASE_SET:RemoveAirbasesByName({"RF Naval-1","RF Naval-2","RF Naval-3","RF Naval-4","RF Naval-5","RF Naval-6","RF Naval-7","RF Naval-8","RF Naval-9","RF Naval-10","RF Naval-11","RF Naval-12","RF Naval-13","RF Naval-14","RF Naval-15","Bassel Al-Assad","H3","H3 Northwest"})
  MESSAGE:New( RED_AIRBASE_SET:Count().. " RED AIRBASES FOUND", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)

  RED_AIRBASE_SET:ForEachAirbase(function(AIRBASE)
    MESSAGE:New("-- " .. AIRBASE:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  end)
end

do -- FIND BLUE AIRBASES
  BLUE_AIRBASE_SET = SET_AIRBASE:New()
  :FilterCoalitions("blue")
  :FilterOnce()
  BLUE_AIRBASE_SET:RemoveAirbasesByName({"Akrotiri","Prince Hassan","King Hussein Air College","Kharab Ishk","BLUE CARRIER-2","BLUE CARRIER-3","BLUE CARRIER-4","BLUE CARRIER-5"})
  MESSAGE:New( BLUE_AIRBASE_SET:Count().. " BLUE AIRBASES FOUND", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)

  BLUE_AIRBASE_SET:ForEachAirbase(function(AIRBASE)
    MESSAGE:New("-- " .. AIRBASE:GetName(), messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  end)
end

do -- FIND RED STATIC - NON USATO
  RED_STATIC_SET = SET_STATIC:New()
  :FilterCoalitions("red")
  :FilterOnce()
  MESSAGE:New( RED_STATIC_SET:Count().. " RED STATIC FOUND", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
end

do -- FIND BLUE STATIC - NON USATO
  BLUE_STATIC_SET = SET_STATIC:New()
  :FilterCoalitions("blue")
  :FilterOnce()
  MESSAGE:New( BLUE_STATIC_SET:Count().. " BLUE STATIC FOUND", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
end

do -- Create red runway set
  RED_RUNWAY_SET = SET_ZONE:New()
  :FilterPrefixes( "RED RUNWAY" )
  :FilterOnce()
end

do -- Create blue runway set
  BLUE_RUNWAY_SET = SET_ZONE:New()
  :FilterPrefixes( "BLUE RUNWAY" )
  :FilterOnce()
end

do -- Create empty red structure set
  RED_STRUCTURE_SET = SET_ZONE:New()
  :FilterPrefixes( "ZZZ" )
  :FilterOnce()
end

do -- Create empty blue structure set
  BLUE_STRUCTURE_SET = SET_ZONE:New()
  :FilterPrefixes( "ZZZ" )
  :FilterOnce()
end

-- INIT MISSION
if true then -- temporaneo, poi il save andrà disattivato meglio

  -- GENERATE NEW MISSION
  MESSAGE:New("Setup mission, please wait...", 5, nil ):ToAll()

  -- AIR DEFENCE FOR EACH STATIC
  --RED_STATIC_SET:ForEachStatic(function(STATIC)
  --  local grp = spawn_RED_AIR_DEFENCE:SpawnFromVec2(STATIC:GetVec2())
  --  removeUnitPositions (grp)
  --end)

  do -- FIND RED STRUCTURE ZONES
    RED_STRUCTURE_SET = SET_ZONE:New()
    :FilterPrefixes( "RED SCENERY" )
    :FilterOnce()
  end
  
  do -- FIND BLUE STRUCTURE ZONES
    BLUE_STRUCTURE_SET = SET_ZONE:New()
    :FilterPrefixes( "BLUE SCENERY" )
    :FilterOnce()
  end

  -- FOR EACH AIRBASE
  local redSAMSpawns = 0
  RED_ANTIAIR_SET = SET_GROUP:New()
  RED_AIRBASE_SET:ForEachAirbase(function(AIRBASE)
  
    -- SPAWN RED SAM GROUP
    --local grp = spawn_RED_SAM:SpawnFromVec2(findPosition(AIRBASE:GetCoordinate()))
    --redSAMSpawns = redSAMSpawns + 1
    --while not checkUnitPositions(grp) do
    --  grp:Destroy()
    --  grp = spawn_RED_SAM:SpawnFromVec2(findPosition(AIRBASE:GetCoordinate()))
    --  redSAMSpawns = redSAMSpawns + 1       
    --end
    --RED_ANTIAIR_SET:AddGroup(grp)
    
    -- SPAWN RED AIR DEFENCE GROUP
    local grp = spawn_RED_AIRBASE_DEFENCE:SpawnFromVec2(AIRBASE:GetVec2())
    removeUnitPositions (grp)
    RED_ANTIAIR_SET:AddGroup(grp)
   
    -- SPAWN RED ARMOR GROUP
    --local grp = spawn_RED_ARMOR:SpawnFromVec2(AIRBASE:GetVec2())
    --removeUnitPositions (grp)       
 
    -- SPAWN RED ARTILLERY GROUP
    --local grp = spawn_RED_ARTILLERY:SpawnFromVec2(AIRBASE:GetVec2())
    --removeUnitPositions (grp)   
       
  end)

  -- SPAWN REARM GROUPS
  --RED_REARM_SET = SET_GROUP:New()   
  --RED_ANTIAIR_SET:ForEachGroupAlive(function (GROUP)   
  --  local grpUnits = #GROUP:GetUnits()
  --  for i = 1, grpUnits do
  --    local Unit = GROUP:GetUnit( i )
  --    if Unit ~= nil then      
  --      local UnitPos = Unit:GetCoordinate()
  --      local distance = airDefenceRadius
  --      RED_REARM_SET:ForEachGroupAlive(function (rearmGrp)
  --        local tempdistance = UnitPos:Get2DDistance(rearmGrp:GetCoordinate())
  --        if tempdistance < distance then distance = tempdistance end
  --      end)   
  --      if distance < airDefenceRadius then
        -- no spawn required
  --      else
  --        local newgrp = spawn_RED_REARM:SpawnFromVec2(Unit:GetVec2())
  --        RED_REARM_SET:AddGroup(newgrp)      
  --      end
  --    end
  --  end 
  --end)
  --RED_REARM_SET:ForEachGroupAlive(function (GROUP)   
  --  removeUnitPositions (GROUP) 
  --end)             
     
  --MESSAGE:New( RED_AIRBASE_SET:Count().. " RED SAM GROUPS SPAWNED IN " .. redSAMSpawns .. " TRIES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
   
  -- FOR EACH AIRBASE  
  --local blueSamSpawns = 0
  --BLUE_ANTIAIR_SET = SET_GROUP:New()
  --BLUE_AIRBASE_SET:ForEachAirbase(function(AIRBASE)
      
    -- SPAWN BLUE SAM GROUP
    --local grp = spawn_BLUE_SAM:SpawnFromVec2(findPosition(AIRBASE:GetCoordinate()))
    --blueSamSpawns = blueSamSpawns + 1
    --while not checkUnitPositions(grp) do
    --  grp:Destroy()
    --  grp = spawn_BLUE_SAM:SpawnFromVec2(findPosition(AIRBASE:GetCoordinate()))
    --  blueSamSpawns = blueSamSpawns + 1       
    --end
    --BLUE_ANTIAIR_SET:AddGroup(grp)

    -- SPAWN BLUE AIR DEFENCE GROUP
    --local grp = spawn_BLUE_AIRBASE_DEFENCE:SpawnFromVec2(AIRBASE:GetVec2())
    --removeUnitPositions (grp)
    --BLUE_ANTIAIR_SET:AddGroup(grp)

    -- SPAWN BLUE ARMOR GROUP
    --local grp = spawn_BLUE_ARMOR:SpawnFromVec2(AIRBASE:GetVec2())
    --removeUnitPositions (grp)    

    -- SPAWN BLUE ARTILLERY GROUP
    --local grp = spawn_BLUE_ARTILLERY:SpawnFromVec2(AIRBASE:GetVec2())
    --removeUnitPositions (grp)               
  --end)

  -- AIR DEFENCE FOR EACH SCENERY
  --BLUE_STRUCTURE_SET:ForEachScenery(function(SCENERY)
  --  local grp = spawn_BLUE_AIR_DEFENCE:SpawnFromVec2(SCENERY:GetVec2())
  --  removeUnitPositions (grp)
    --BLUE_ANTIAIR_SET:AddGroup(grp)
  --  MESSAGE:New( "Adding blue scenery air defence", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  --end)

  --RED_STRUCTURE_SET:ForEachScenery(function(SCENERY)
  --  local grp = spawn_RED_AIR_DEFENCE:SpawnFromVec2(SCENERY:GetVec2())
  --  removeUnitPositions (grp)
    --RED_ANTIAIR_SET:AddGroup(grp)
  --  MESSAGE:New( "Adding red scenery air defence", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  --end)
  
  -- SPAWN REARM GROUPS
  --BLUE_REARM_SET = SET_GROUP:New() 
  --BLUE_ANTIAIR_SET:ForEachGroupAlive(function (GROUP)   
  --  local grpUnits = #GROUP:GetUnits()
  --  for i = 1, grpUnits do
  --    local Unit = GROUP:GetUnit( i )
  --    if Unit ~= nil then
  --      local UnitPos = Unit:GetCoordinate()
  --      local distance = airDefenceRadius
  --      BLUE_REARM_SET:ForEachGroupAlive(function (rearmGrp)
  --        local tempdistance = UnitPos:Get2DDistance(rearmGrp:GetCoordinate())
  --        if tempdistance < distance then distance = tempdistance end
  --      end)   
  --      if distance < airDefenceRadius then
        -- no spawn required
  --      else
  --        local newgrp = spawn_BLUE_REARM:SpawnFromVec2(Unit:GetVec2())
  --        BLUE_REARM_SET:AddGroup(newgrp)      
  --      end
  --    end
  --  end 
  --end)
  --BLUE_REARM_SET:ForEachGroupAlive(function (GROUP)   
  --  removeUnitPositions (GROUP) 
  --end)  

  --MESSAGE:New( BLUE_AIRBASE_SET:Count().. " BLUE SAM GROUPS SPAWNED IN " .. blueSamSpawns .. " TRIES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG) 
  
  --SAVE TOTAL UNIT COUNT
  day = 1
  totalRedUnitCount = 0
  totalBlueUnitCount = 0
  local AllGroups = SET_GROUP:New():FilterCategories("ground"):FilterActive(true):FilterOnce() 
  SCHEDULER:New( nil, function()
    AllGroups:ForEachGroupAlive(function (GROUP)
      if GROUP:GetCoalition() == 1 then totalRedUnitCount = totalRedUnitCount + getAliveUnitsGrp(GROUP) end
      if GROUP:GetCoalition() == 2 then totalBlueUnitCount = totalBlueUnitCount + getAliveUnitsGrp(GROUP) end
    end)

    -- SAVE SQUADRONS
    aircraftRED = totalAircraftRED
    aircraftBLUE = totalAircraftBLUE

  end, {}, 1)

  MESSAGE:New("Completed", 5, nil ):ToAll()
  
end

--setStage("N")
--setStage("W")
--setStage("S")

do -- RED SETS

  RED_TARGET_SET = SET_GROUP:New()
  
  RED_SAM_SET = SET_GROUP:New()
  :FilterPrefixes("RED SAM")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {RED_SAM_SET}, 1 ) 

  RED_ARMOR_SET = SET_GROUP:New()
  :FilterPrefixes("RED ARMOR")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {RED_ARMOR_SET}, 1 )
    
  RED_AIR_DEFENCE_SET = SET_GROUP:New()
  :FilterPrefixes("RED AIR DEFENCE")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {RED_AIR_DEFENCE_SET}, 1 )
  
  RED_ARTILLERY_SET = SET_GROUP:New()
  :FilterPrefixes("RED ARTILLERY")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {RED_ARTILLERY_SET}, 1 ) 

  --RED_CONVOY_SET = SET_GROUP:New() -- non usato perchè generati dinamicamente
  --:FilterPrefixes("RED CONVOY")
  --:FilterActive(true)
  --:FilterOnce()
  --SCHEDULER:New( nil, saveTargetData, {RED_CONVOY_SET}, 1 ) 

  RED_BASE_SET = SET_GROUP:New()
  :FilterPrefixes("RED BASE")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {RED_BASE_SET}, 1 ) 

  --SCHEDULER:New( nil, saveStructureData, {RED_STRUCTURE_SET}, 1 )          
end

do -- BLUE SETS

  BLUE_TARGET_SET = SET_GROUP:New()
  
  BLUE_SAM_SET = SET_GROUP:New()
  :FilterPrefixes("BLUE SAM")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {BLUE_SAM_SET}, 1 )
    
  BLUE_ARMOR_SET = SET_GROUP:New()
  :FilterPrefixes("BLUE ARMOR")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {BLUE_ARMOR_SET}, 1 )
    
  BLUE_AIR_DEFENCE_SET = SET_GROUP:New()
  :FilterPrefixes("BLUE AIR DEFENCE")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {BLUE_AIR_DEFENCE_SET}, 1 )
 
  BLUE_ARTILLERY_SET = SET_GROUP:New()
  :FilterPrefixes("BLUE ARTILLERY")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {BLUE_ARTILLERY_SET}, 1 )

  --BLUE_CONVOY_SET = SET_GROUP:New() -- non usato perchè generati dinamicamente
  --:FilterPrefixes("BLUE CONVOY")
  --:FilterActive(true)
  --:FilterOnce()
  --SCHEDULER:New( nil, saveTargetData, {BLUE_CONVOY_SET}, 1 )     

  BLUE_BASE_SET = SET_GROUP:New()
  :FilterPrefixes("BLUE BASE")
  :FilterActive(true)
  :FilterOnce()
  SCHEDULER:New( nil, saveTargetData, {BLUE_BASE_SET}, 1 ) 
  
  --SCHEDULER:New( nil, saveStructureData, {BLUE_STRUCTURE_SET}, 1 ) 
end

--do -- AIRBASE SETS
--  SCHEDULER:New( nil, checkAirbases, {"red"}, 1 )
--  SCHEDULER:New( nil, checkAirbases, {"blue"}, 1 )
--end

do -- CLIENT SET
  CLIENTS_SET = SET_CLIENT:New()
  :FilterCategories("plane")
  :FilterOnce()
end

do -- INIT ZONES
  MESSAGE:New( "INIT ZONES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  --RED_CAP_ZONE = ZONE_POLYGON:New( "RED CAP ZONE", GROUP:FindByName( "RED CAP ZONE" ) ) -- gestita in altro LUA per RF
  BLUE_CAP_ZONE = ZONE_POLYGON:New( "BLUE CAP ZONE", GROUP:FindByName( "BLUE CAP ZONE" ) )  
end

do -- INIT AIR DEFENCES
  MESSAGE:New( "INIT AIR DEFENCES", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  local RED_SEAD_DEFENCE = SEAD:New({ "RED SAM","RED AIR DEFENCE"})
  local BLUE_SEAD_DEFENCE = SEAD:New({ "BLUE SAM","BLUE AIR DEFENCE"})
end

do -- INIT CARRIER  & TANKER
  MESSAGE:New( "INIT CARRIER  & TANKER", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
    
  local BLUE_CARRIER = GROUP:FindByName( "BLUE CARRIER" )
  BLUE_CARRIER:PatrolRoute()
  BLUE_CARRIER:OptionROE(ENUMS.ROE.WeaponHold)
    
    -- CARRIER TANKER
  local BLUE_TANKER_TEXACO= RECOVERYTANKER:New(UNIT:FindByName("CVN-71 Theodore Roosevelt"), "BLUE TANKER TEXACO")
  BLUE_TANKER_TEXACO:SetTakeoffAir()
  BLUE_TANKER_TEXACO:SetTACAN(81, "TEX")
  BLUE_TANKER_TEXACO:SetRadio(261,"AM")
  BLUE_TANKER_TEXACO:SetCallsign(1)
  BLUE_TANKER_TEXACO:Start()
end

do -- INIT TANKERS
  --MESSAGE:New( "INIT TANKER", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  --SCHEDULER:New( nil, spawnTanker, {spawn_BLUE_TANKER_SHELL,"blue"}, minDispatchTime )
  -- SCHEDULER:New( nil, spawnTanker, {spawn_BLUE_TANKER_ARCO,"blue"}, minDispatchTime )
end

do -- INIT AWACS
  MESSAGE:New( "INIT AWACS", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  local BLUEAWACS = GROUP:FindByName( "BLUE AWACS" )
  BLUEAWACS:CommandSetUnlimitedFuel(true)
--  SCHEDULER:New( nil, spawnAwacs, {"blue"}, minDispatchTime )
end

do -- INIT DISPATCHER
  MESSAGE:New( "INIT DISPATCHER", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  --dispatcher("red", "redCapZone")
  --dispatcher("red", "redZone1")
  --dispatcher("red", "redZone2")
  dispatcher("blue", "blueCapZone")
  SCHEDULER:New( nil, dispatcher, {"blue", "blueZone1"}, 5 )
  SCHEDULER:New( nil, dispatcher, {"blue", "blueZone2"}, 10 )

  SCHEDULER:New( nil, dispatcher, {"blue", nil}, math.random(minDispatchTime,maxDispatchTime) )
  --SCHEDULER:New( nil, dispatcher, {"red", nil}, math.random(minDispatchTime,maxDispatchTime) )
end

do -- INIT CLIENTS
  MESSAGE:New( "INIT CLIENTS", messageTime, nil ):ToLogIf(DEBUGLOG):ToAllIf(DEBUG)
  CLIENTS_SET:ForEachClient(function(CLIENT)
    initClient(CLIENT)  
  end)
end
