-- Define a SET_GROUP object that builds a collection of groups that define the EWR network.
-- Here we build the network with all the groups that have a name starting with DF CCCP AWACS and DF CCCP EWR.
DetectionSetGroup = SET_GROUP:New()
DetectionSetGroup:FilterPrefixes( { "RF AWACS", "RF EWR" } )
DetectionSetGroup:FilterStart()

RFAWACS = GROUP:FindByName( "RF AWACS" )
RFAWACS:CommandSetUnlimitedFuel(true)

RFAWACSEscort = GROUP:FindByName( "Escort Red" )
RFAWACSEscort:CommandSetUnlimitedFuel(true)

Detection = DETECTION_AREAS:New( DetectionSetGroup, 30000 )

-- Setup the A2A dispatcher, and initialize it.
A2ADispatcher = AI_A2A_DISPATCHER:New( Detection )

-- Setup the border zone. 
-- In this case the border is a POLYGON, 
-- which takes the waypoints of a late activated group with the name CCCP Border as the boundaries of the border area.
-- Any enemy crossing this border will be engaged.
RFBorderZone = ZONE_POLYGON:New( "RF Border", GROUP:FindByName( "RF Border" ) )
A2ADispatcher:SetBorderZone( RFBorderZone )

-- Initialize the dispatcher, setting up a border zone. This is a polygon, 
-- which takes the waypoints of a late activated group with the name CCCP Border as the boundaries of the border area.
-- Any enemy crossing this border will be engaged.
RFBorderZone = ZONE_POLYGON:New( "RF Border", GROUP:FindByName( "RF Border" ) )
--A2ADispatcher:SetBorderZone( RFBorderZone )


A2ADispatcher:SetTacticalDisplay( false )



-- Setup the squadrons.

A2ADispatcher:SetSquadron( "Bassel Al-Assad", AIRBASE.Syria.Bassel_Al_Assad, { "SQ RF SU-27" }, 10 )
A2ADispatcher:SetSquadronGci( "Bassel Al-Assad", 1000, 1500 )
A2ADispatcher:SetSquadronTakeoffFromRunway( "Bassel Al-Assad" )

A2ADispatcher:SetSquadron( "Kuznetsov", "Kuznetsov", { "SQ RF SU-33" }, 20 )
A2ADispatcher:SetSquadronGci( "Kuznetsov", 900, 1200 )
A2ADispatcher:SetSquadronOverhead( "Kuznetsov", 1.2 )
A2ADispatcher:SetSquadronTakeoff( "Kuznetsov", AI_A2A_DISPATCHER.Takeoff.Runway )
A2ADispatcher:SetSquadronLandingAtRunway( "Kuznetsov" )

CleanUp = CLEANUP_AIRBASE:New( { AIRBASE.Syria.Bassel_Al_Assad } )


